proc _cameraSettingsWin {} {
	global oText cam scCanv canvas
	set iniI [$oText search "Camera \[" 1.0 end]
	if {$iniI==""} {tk_messageBox -message "No camera statement!"; return}
	if [winfo exists .cm] {
		# 
		# La toplevel .cm non viene destroyed quindi prima di rivisualizzarla occorre
		# fare _read_cameraSettings, nel caso si sia fatto -cambiaValori -Dismiss
		# 
		if ![winfo viewable .cm] {
			_read_cameraSettings
			wm deiconify .cm; raise .cm
		}
		return
	}
	toplevel .cm
	wm title .cm "Camera settings"
	wm geometry .cm +[winfo pointerx .]+[winfo pointery .]
	wm transient .cm .
	wm resizable .cm 0 0
	wm protocol .cm WM_DELETE_WINDOW {wm withdraw .cm}
	frame .cm.s
	frame .cm.s.bt
	pack .cm.s.bt -anchor n
	bind .cm <Escape> {wm withdraw .cm}
	_insertCbLbEn .cm.s.bt.1 10 "Field of view" cam(fovOn) cam(fov) n
	_insertCbLbEn .cm.s.bt.3 10 "Frame aspect ratio" cam(aratioOn) cam(aratio) n
	_insertCbLb2En .cm.s.bt.2 6 "Format" cam(formatOn) cam(formatx) cam(formaty) \
		"Horizontal resolution" "Vertical resolution"
	_insertCbLb3En .cm.s.bt.7 5 "Depth of field  " cam(dofOn) cam(dofAp) cam(dofDs) \
		cam(dofSm) "Size of aperture" "Focal distance" "Sample rays"
	_insertCbLb2En .cm.s.bt.8 6 "Exposure" cam(expOn) cam(expGn) cam(expGa) \
		"Gain" "Gamma"
	_insertCbLb2En .cm.s.bt.4 6 "Clipping planes" cam(cplanesOn) cam(cplanes1) \
		cam(cplanes2) "Near plane" "Far plane"
	_insertCbLbMb .cm.s.bt.9 3 "Lens model" "1 2 3 4 5 6" \
		"Perspective Orthographic WideAngle FishEye Panoramic Omnimax" cam(lmodelOn) \
			cam(lmodel)	n
	_insertCbLbMb .cm.s.bt.5 3 "Antialiasing" "1 2 3 4 5 6 7 8 9 10" {} \
		cam(aaOn) cam(aa) n
	_insertCbLbMb .cm.s.bt.6 3 "Undersampling" "1 2 3 4 5 6 7 8 9 10" {} \
		cam(usampOn) cam(usamp) n
	_insert2Butt .cm.s.bts 10 10 "Apply" "Apply & Render" _apply_cameraSettings \
		{_apply_cameraSettings; _render}
	pack .cm.s.bts -side bottom -anchor s
	frame .cm.c -relief sunken -bd 1
	frame .cm.c.m
	pack .cm.c.m -fill x -expand 1
	_insertLbMb2 .cm.c.m.v 5 10 {} {XY XZ YZ} {(Top) (Front) (Side)} \
		{{_drawCameraView XY x y} {_drawCameraView XZ x z} {_drawCameraView YZ y z}} \
		canvas(2dView)
	label .cm.c.m.msg1 -width 14 -textvariable canvas(info1)
	label .cm.c.m.msg2 -width 14 -textvariable canvas(info2) -fg blue
	pack .cm.c.m.msg1 .cm.c.m.msg2 -side left -anchor w
	pack .cm.c.m.v -side right -anchor e
	_insertCanvas .cm.c.c scCanv $canvas(canvasX) $canvas(canvasY) bottom
	pack .cm.c .cm.s -side left -padx 2 -pady 2 -anchor s -fill y -expand 1
	_canvasMenu
	_canvasBindings
	_read_cameraSettings
	_drawGrid
	_drawCameraView XY x y
	_canvSnapViewTo cameraLookAt
}

proc _read_cameraSettings {} {
	global oText cam render
	# 
	# Occorre inizializzare tutti i valori di default, prima.
	# 
	source src/defaults.tcl
	set txtI [$oText search "Camera \[" 1.0 end]
	if {$txtI==""} {
		tk_messageBox -message "Camera statement not found." -icon warning -parent .
		return
	}
	set cam(fovOn) 0
	set cam(formatOn) 0
	set cam(aratioOn) 0
	set cam(cplanesOn) 0
	set cam(aaOn) 0
	set cam(usampOn) 0
	set cam(dofOn) 0
	set cam(expOn) 0
	set cam(lmodelOn) 0
	set cdl [$oText get "$txtI +1l linestart" "$txtI +1l lineend"]; # cam data line
	set cam(px) [string trimright [string trimleft [lindex $cdl 0] (] ,]
	set cam(py) [string trimright [lindex $cdl 1] ,]
	set cam(pz) [string trimright [lindex $cdl 2] ),]
	set cam(lx) [string trimright [string trimleft [lindex $cdl 3] (] ,]
	set cam(ly) [string trimright [lindex $cdl 4] ,]
	set cam(lz) [string trimright [lindex $cdl 5] ),]
	set cam(tmpPx) $cam(px); set cam(tmpLx) $cam(lx)
	set cam(tmpPy) $cam(py); set cam(tmpLy) $cam(ly)
	set cam(tmpPz) $cam(pz); set cam(tmpLz) $cam(lz)
	set line {}
	while {$line!="\]"} {
		set txtI [expr $txtI +1.0]
		set line [$oText get $txtI "$txtI lineend"]
		if [string match {*FieldOfView *} $line] {
			set cam(fovOn) 1; set cam(fov) [lindex $line end]
		}
		if [string match {*Format *} $line] {
			set cam(formatOn) 1
			set s [split [lindex $line end] ,]
			set cam(formatx) [string trimleft  [lindex $s 0] (]
			set cam(formaty) [string trimright [lindex $s 1] )]
		}
		if [string match {*FrameAspectRatio *} $line] {
			set cam(aratioOn) 1; set cam(aratio) [lindex $line end]
		}
		if [string match {*Clipping *} $line] {
			set cam(cplanesOn) 1
			set s [split [lindex $line end] ,]
			set cam(cplanes1) [string trimleft  [lindex $s 0] (]
			set cam(cplanes2) [string trimright [lindex $s 1] )]
		}
		if [string match {*Antialiasing *} $line] {
			set cam(aaOn) 1; set cam(aa) [lindex $line end]
		}
		if [string match {*Undersampling *} $line] {
			set cam(usampOn) 1; set cam(usamp) [lindex $line end]
		}
		if [string match {*DepthOfField *} $line] {
			set cam(dofOn) 1
			set s [split [lindex $line end] ,]
			set cam(dofAp) [string trimleft  [lindex $s 0] (]
			set cam(dofDs) [lindex $s 1]
			set cam(dofSm) [string trimright [lindex $s 2] )]
		}
		if [string match {*Exposure *} $line] {
			set cam(expOn) 1
			set s [split [lindex $line end] ,]
			set cam(expGn) [string trimleft  [lindex $s 0] (]
			set cam(expGa) [string trimright [lindex $s 1] )]
		}
		if [string match {*LensModel *} $line] {
			set cam(lmodelOn) 1; set cam(lmodel) [lindex $line end]
		}
	}
	set render(sizew) $cam(formatx)
	set render(sizeh) $cam(formaty)
}

proc _apply_cameraSettings {} {
	global oText cam
	foreach x {{fov fov FieldOfView} {aratio aratio AspectRatio}
		{cplanes cplanes1 ClippingPlanes} {cplanes cplanes2 ClippingPlanes}
		{dof dofAp DepthOfField} {dof dofDs DepthOfField} {exp expGn Exposure}
		{exp expGa Exposure}} {
			set varOnName [lindex $x 0]
			if [set cam(${varOnName}On)] {
				set tmpV [_isFlt noNull $cam([lindex $x 1]) [lindex $x 2] {}]
				if {$tmpV=="no"} {return} else {set cam([lindex $x 1]) $tmpV}
			}
	}
	foreach x {{format formatx Format} {format formaty Format}
		{dof dofSm "DepthOfField sample"} {aa aa Antialiasing}
		{usamp usamp Undersampling}} {
			set varOnName [lindex $x 0]
			if [set cam(${varOnName}On)] {
				set tmpV [_isInt noNull $cam([lindex $x 1]) [lindex $x 2] {}]
				if {$tmpV=="no"} {return} else {set cam([lindex $x 1]) $tmpV}
			}
	}
	_state $oText normal
	set iniI [$oText search "Camera \[" 1.0 end]
	set endI [$oText search "\]" $iniI end]; # il primo \] che trova!
	$oText delete "$iniI +2l" "$endI +1l"
	set fovLine "  FieldOfView $cam(fov)"
	set formatLine "  Format ($cam(formatx),$cam(formaty))"
	set aratioLine "  FrameAspectRatio $cam(aratio)"
	set cplanesLine "  Clipping ($cam(cplanes1),$cam(cplanes2))"
	set aaLine "  Antialiasing $cam(aa)"
	set usampLine "  Undersampling $cam(usamp)"
	set dofLine "  DepthOfField ($cam(dofAp),$cam(dofDs),$cam(dofSm))"
	set expLine "  Exposure ($cam(expGn),$cam(expGa))"
	set lmodelLine "  LensModel $cam(lmodel)"
	$oText insert "$iniI +2l" \]\n
	foreach v {lmodel exp dof usamp aa cplanes aratio format fov} {
		if [set cam(${v}On)] {$oText insert "$iniI +2l" [set ${v}Line]\n}
	}
	_state $oText disabled
	_applyCameraCoords write
}

proc _applyCameraCoords {type} {
	# 
	# type==info1 fornisce le coordinate camPos sulla label di info, durante B1-Motion
	# type==info2 fornisce le coordinate camLkt sulla label di info, durante B1-Motion
	# type==write scrive nel VIB
	# 
	# Le nuove coordinate vengono calcolate rispetto ad un centro simbolico
	# rappresentato dall'item linea 'center', che subisce gli scaling dello zoom
	# allo stesso modo degli altri items del canvas. Dato che le operazioni di zoom
	# non hanno sempre lo stesso point-center nel canvas (ogni volta il point-center
	# e' l'equivalente canvas del centro della window-canvas) perdo il controllo delle
	# coordinate dei vari items.
	# 
	global canvas scCanv cam oText
	set camCoords [$scCanv coords camLine]; # coordinate canvas della linea camera
	set cntCoords [$scCanv coords center]; # coordinate canvas del centro della grid
	set camPx [format %.3f [expr [lindex $camCoords 0]/$canvas(zoom)]]
	set camPy [format %.3f [expr [lindex $camCoords 1]/$canvas(zoom)]]
	set camLx [format %.3f [expr [lindex $camCoords 2]/$canvas(zoom)]]
	set camLy [format %.3f [expr [lindex $camCoords 3]/$canvas(zoom)]]
	set cntPx [format %.3f [expr [lindex $cntCoords 0]/$canvas(zoom)]]
	set cntPy [format %.3f [expr [lindex $cntCoords 1]/$canvas(zoom)]]
	# 
	# Calcolo coordinate x in unita' POV:
	# 
	set oper -; set sign -
	if {$camPx>0&&$cntPx<0} {set oper +}
	if {$camPx<0&&$cntPx>0} {set oper +}
	if {$camPx>$cntPx} {set sign {}}
	set newP1 [format %.3f [expr abs(abs($camPx) $oper abs($cntPx))*${sign}1]]
	set oper -; set sign -
	if {$camLx>0&&$cntPx<0} {set oper +}
	if {$camLx<0&&$cntPx>0} {set oper +}
	if {$camLx>$cntPx} {set sign {}}
	set newL1 [format %.3f [expr abs(abs($camLx) $oper abs($cntPx))*${sign}1]]
	# 
	# Calcolo coordinate y in unita' POV:
	# 
	set oper -; set sign -
	if {$camPy>0&&$cntPy<0} {set oper +}
	if {$camPy<0&&$cntPy>0} {set oper +}
	if {$camPy<$cntPy} {set sign {}}
	set newP2 [format %.3f [expr abs(abs($camPy) $oper abs($cntPy))*${sign}1]]
	set oper -; set sign -
	if {$camLy>0&&$cntPy<0} {set oper +}
	if {$camLy<0&&$cntPy>0} {set oper +}
	if {$camLy<$cntPy} {set sign {}}
	set newL2 [format %.3f [expr abs(abs($camLy) $oper abs($cntPy))*${sign}1]]
	# 
	# Visualizzazione dei valori finali POV nella label di info:
	# 
	if {$type=="info1"} {set canvas(info2) "$newP1 $newP2"}
	if {$type=="info2"} {set canvas(info2) "$newL1 $newL2"}
	# 
	# Valori temporanei necessari durante il changeView del canvas:
	# 
	if {$canvas(2dView)=="XY"} {
		set cam(tmpPx) $newP1; set cam(tmpPy) $newP2
		set cam(tmpLx) $newL1; set cam(tmpLy) $newL2
	} elseif {$canvas(2dView)=="XZ"} {
		set cam(tmpPx) $newP1; set cam(tmpPz) $newP2
		set cam(tmpLx) $newL1; set cam(tmpLz) $newL2
	} else {
		set cam(tmpPy) $newP1; set cam(tmpPz) $newP2
		set cam(tmpLy) $newL1; set cam(tmpLz) $newL2
	}
	if {$type=="write"} {
		set cam(px) $cam(tmpPx); set cam(lx) $cam(tmpLx)
		set cam(py) $cam(tmpPy); set cam(ly) $cam(tmpLy)
		set cam(pz) $cam(tmpPz); set cam(lz) $cam(tmpLz)
		_state $oText normal
		set iniI [$oText search "Camera \[" 1.0 end]
		_delLine "$iniI +1l"
		set dataLine \
				"  ($cam(px), $cam(py), $cam(pz)),\
				($cam(lx), $cam(ly), $cam(lz)), (0.0, 0.0, 1.0)\n"
		$oText insert "$iniI +1l" $dataLine
		_state $oText disabled
	}
	# _puts "Pos: $newP1 $newP2 $newPx Loc: $newL1 $newL2"
}

