# -----------------------------------------------------------------
# Interfaccia grafica principale
# -----------------------------------------------------------------
######################################################################################
# wm commands
######################################################################################
wm title . $gui(appTitle)
. config -menu .mainM

######################################################################################
# option add
######################################################################################
option add *font $gui(defFont)
option add *Checkbutton.borderWidth 0
option add *Entry.borderWidth 1
option add *Entry.justify c
option add *Entry.background "grey90"
option add *Label.borderWidth 1
option add *Listbox.selectBackground "grey85"
option add *Listbox.selectForeground "black"
option add *Listbox.selectBorderWidth 0
option add *Listbox.borderWidth 1
option add *Text.cursor "left_ptr"
option add *Text.borderWidth 1
option add *Menu.disabledForeground "grey50"
option add *Menu.borderWidth 1
option add *Scale.borderWidth 1
# option add *Frame.borderWidth 1; # funziona male

######################################################################################
# Bindings globali
######################################################################################
bind . <Control-s> _saveVLfiles
bind . <Control-S> _saveVLfilesAs
bind . <Control-q> _exit
bind . <Control-h> _stopParse
bind . <Control-p> _parseInputFile
bind . <Control-i> _setInputFile
bind . <Control-o> _setOutputFile
bind . <Control-l> _openVLfiles
bind . <Control-r> _render
# bind . <Control-e> _seWin
bind Text <Control-a> {%W tag add sel 1.0 end}
bind . <F1> {_toggleFrame scrollbars}
bind . <F2> {_toggleFrame vibFrame}
bind . <F3> {_toggleFrame messFrame}
bind . <F4> {_toggleFrame renderFrame}
bind Entry <ButtonRelease-3> {focus %W; %W selection range 0 end}

######################################################################################
# Icone
######################################################################################
set opIm [image create photo -file icons/open.png]
set rnIm [image create photo -file icons/run1.png]
set svIm [image create photo -file icons/save.png]
set nwIm [image create photo -file icons/new.png]

######################################################################################
# Popup menus
######################################################################################
menu .vibM -tearoff 0
.vibM add command -label "Go to line ..." -accel "<Ctrl-l>" -command _goToLine
.vibM add command -label "Find ..." -accel "<Ctrl-f>" -command _findInVib
menu .tree -tearoff 0; # .tree viene sviluppato in _popupTree
menu .tree.m1 -tearoff 0 -postcommand _matsInScene
menu .ls -tearoff 0; # .ls viene sviluppato in _verifyLightsList
menu .ls.d -tearoff 0
.ls.d add command -label Confirm -command _deleteMultiLights
menu .matM -tearoff 0
.matM add command -label "Assign material to tree selection" -comm "_setMatToSele add"\
	-foreground blue
.matM add command -label "View selected material" -command _viewMaterial
.matM add separator
.matM add command -label "Query object materials" -command _queryObjsMaterialsWin
.matM add cascade -label "Query objects with material" -menu .matM.m
.matM add separator
.matM add command -label "Add materials from archive ..." -command _loadMatArchFile
menu .matM.m -tearoff 0 -postcommand _matsInScene

######################################################################################
# Main Toolbar Menu
######################################################################################
menu .mainM
.mainM add cascade -label "File" -menu .mainM.m1
.mainM add cascade -label "View" -menu .mainM.m2
.mainM add cascade -label "Scene" -menu .mainM.m4
.mainM add cascade -label "Tools" -menu .mainM.m5
.mainM add cascade -label "Help" -menu .mainM.m3
menu .mainM.m1 -tearoff 0
.mainM.m1 add command -label "Set POV input file ..." -comm _setInputFile -acc <Ctrl-i>
.mainM.m1 add command -label "Set VIB output file ..." -comm _setOutputFile \
	-acc <Ctrl-o>
.mainM.m1 add separator
.mainM.m1 add command -label "Start conversion" -comm _parseInputFile -accel <Ctrl-p>
.mainM.m1 add command -label "Abort conversion" -comm _stopParse -accel <Ctrl-h>
.mainM.m1 add separator
.mainM.m1 add command -label "Save current VIB" -accel "<Ctrl-s>" -comm _saveVLfiles
.mainM.m1 add command -label "Save current VIB as ..." -accel "<Ctrl-S>" \
	-comm _saveVLfilesAs
.mainM.m1 add separator
.mainM.m1 add command -label "Load VIB ..." -command _openVLfiles -acc <Ctrl-l>
.mainM.m1 add separator
.mainM.m1 add command -label "Setup ..." -command {_setupWin 0}
.mainM.m1 add command -label "Settings ..." -command _settingsWin
.mainM.m1 add separator
.mainM.m1 add command -label "Exit" -accel "<Ctrl-q>" -command _exit
menu .mainM.m2 -tearoff 0
.mainM.m2 add checkbutton -label "Scrollbars" -accel <F1> -var gui(scrollbars) \
	-selectcolor blue -command _scrollbars
.mainM.m2 add checkbutton -label "VIB window" -accel <F2> -var gui(vibFrame) \
	-selectcolor blue -command _vibFrame
.mainM.m2 add checkbutton -label "Log window" -accel <F3> -var gui(messFrame) \
	-selectcolor blue -command _messFrame
.mainM.m2 add checkbutton -label "Render window" -accel <F4> -var gui(renderFrame) \
	-selectcolor blue -command _renderFrame
.mainM.m2 add separator
.mainM.m2 add command -label "POV input" -command _showPov
.mainM.m2 add command -label "VIB output" -command _showVib
.mainM.m2 add command -label "GEO output" -command _showGeo
.mainM.m2 add separator
.mainM.m2 add command -label "Conversion log" -command _showLog
menu .mainM.m3 -tearoff 0
.mainM.m3 add command -label "About" -command _aboutM2vl
.mainM.m3 add command -label "Supported Moray objects" -command _supported
.mainM.m3 add command -label "Usage" -command _helpM2vl
menu .mainM.m4 -tearoff 0
.mainM.m4 add command -label "Camera ..." -command _cameraSettingsWin
.mainM.m4 add command -label "Sky & Sun ..." -command _skysunWin
.mainM.m4 add command -label "General ..." -command _generalWin
.mainM.m4 add command -label "Options ..." -command _optionsWin
.mainM.m4 add separator
.mainM.m4 add command -label "ReadArchive ..." -command {_readArchiveMngt {} .}
.mainM.m4 add separator
.mainM.m4 add command -label "List skipped items" -command _listSkipped
menu .mainM.m5 -tearoff 0
.mainM.m5 add command -label "Shader editor" -accel <Ctrl-e> -state disabled
.mainM.m5 add command -label "VirtuaLight GUI" -command {
	# In Win98 apre tk_messageBox anche senza errore, ma solo per il mess di output
	# 	if [catch {exec vlightgui} vlgrun] {
	# 		tk_messageBox -message "Error in running VirtuaLight GUI:\n$vlgrun" \
	# 			-icon error -parent .
	# 	}
	catch {exec vlightgui &}
}

######################################################################################
# Frame .f1 di sinistra (bottoni e listboxes)
######################################################################################
frame .f1
pack .f1 -side left -fill both

frame .f1.f
frame .f1.f.i -relief ridge -bd 2
frame .f1.f.o -relief ridge -bd 2
label .f1.f.i.lb -width 26 -text "$inputFile(name)" -textvar inputFile(name)
label .f1.f.o.lb -width 26 -text "$outputFile(name)" -textvar outputFile(name)
button .f1.f.i.b -image $opIm -command _setInputFile
button .f1.f.o.b -image $opIm -command _setOutputFile
button .f1.f.i.go -image $rnIm -command _parseInputFile
button .f1.f.o.sv -image $svIm -command _saveVLfiles
_bindEnterLeave .f1.f.i.lb "Current input file"
_bindEnterLeave .f1.f.o.lb "Current output file"
_bindEnterLeave .f1.f.i.b "Set Moray/POV input file"
_bindEnterLeave .f1.f.o.b "Set Vib output file"
_bindEnterLeave .f1.f.i.go "Parse input file"
_bindEnterLeave .f1.f.o.sv "Save Vib output file"
pack .f1.f -fill x
pack .f1.f.i .f1.f.o -fill x
pack .f1.f.i.lb -side left -anchor w
pack .f1.f.i.b .f1.f.i.go -side left -fill y -anchor e
pack .f1.f.o.lb -side left
pack .f1.f.o.b .f1.f.o.sv -side left -fill y -anchor e
label .f1.sep1
pack .f1.sep1
# 
# `lbLights` `lbShapes` `lbDecs`:
# 
label .f1.lllb -fg white -text "Lights:"
frame .f1.ll
set lbLights [listbox .f1.ll.l -height 8 -yscrollcommand {.f1.ll.s set} \
	-selectmode extended -exportselection false -foreground $gui(activeColor) \
	-selectforeground $gui(activeColor)]
bind $lbLights <ButtonRelease-1> {_searchInText light $lbLights %y}
bind $lbLights <ButtonRelease-3> "_verifyLightsList %X %Y %y"
_bindEnterLeave $lbLights "Lights in scene (MB3: options)"
scrollbar .f1.ll.s -command {.f1.ll.l yview} -orient vert
pack .f1.lllb .f1.ll -fill x -anchor n
pack .f1.ll.l -side left -fill x -expand 1
pack .f1.ll.s -side right -fill y

label .f1.shlb -fg white -text "Toplevel items:"
frame .f1.sh
set lbShapes [listbox .f1.sh.l -height 10 -yscrollcommand {.f1.sh.s set} \
	-selectmode single -exportselection false]
bind $lbShapes <ButtonRelease-1> {_searchInText toplv $lbShapes %y}
_bindEnterLeave $lbShapes "Toplevel objects in scene"
scrollbar .f1.sh.s -command {.f1.sh.l yview} -orient vert
pack .f1.shlb -fill x -anchor n
pack .f1.sh -fill both -expand 1
pack .f1.sh.l -side left -fill both -expand 1
pack .f1.sh.s -side right -fill y

label .f1.delb -fg white -text "Declared items:"
frame .f1.de
set lbDecs [listbox .f1.de.l -height 10 -yscrollcommand {.f1.de.s set} \
	-selectmode single -exportselection false]
bind $lbDecs <ButtonRelease-1> {_searchInText decob $lbDecs %y}
bind $lbDecs <ButtonRelease-3> {_findDecInVib}
_bindEnterLeave $lbDecs "Declared items (MB3: find next in Vib)"
scrollbar .f1.de.s -command {.f1.de.l yview} -orient vert
pack .f1.delb -fill x
pack .f1.de -fill x -anchor s
pack .f1.de.l -side left -fill x -expand 1
pack .f1.de.s -side right -fill y
# label di tooltips
label .f1.h -fg blue -relief sunken -bd 2
pack .f1.h -fill x -expand 1 -anchor s

######################################################################################
# Frame .f2 di destra dei text Widgets
######################################################################################
frame .f2
_insertText .f2.t 40 10 grey85 black $gui(textFont) oText
bind $oText <ButtonRelease-3> "tk_popup .vibM %X %Y"
bind $oText <Control-l> _goToLine
bind $oText <Control-f> _findInVib
_bindEnterLeave $oText "Vib file (MB3: options)"
# 
# `mess` il contenitore txt dei messaggi:
# 
_insertText .f2.t2 40 10 grey45 white $gui(messFont) mess
$mess config -tabs 20 -selectbackground black
bind $mess <1> "$mess tag remove hlight 1.0 end"
_bindEnterLeave $mess "Log / messages"
# 
# tri counter label
# 
label .f2.t2.lb -relief flat -bd 2 -textvariable messLb -justify left
pack .f2.t2.lb -side bottom -anchor w
_bindEnterLeave .f2.t2.lb "Triangles counter"
#  
# Frame .f3 di destra del Tree
# 
frame .f3
label .f3.lb -relief ridge -bd 2
frame .f3.y
pack .f3.lb -fill x
pack .f3.y -fill both -expand 1
set tree .f3.y.w 
Tree:create $tree -bg grey45 -width 200 -height 400 -yscrollcommand {.f3.y.sb set} \
	-xscrollcommand {.f3.sb set} -relief sunken -bd 2
$tree bind white <1> "_setSelection white %x %y"
$tree bind cyan <1> "_setSelection cyan2 %x %y"
$tree bind cyan <Shift-1> "_setSelection cyan %x %y"
bind $tree <2> "$tree scan mark 0 %y"
bind $tree <B2-Motion> "$tree scan dragto 0 %y"
bind $tree <ButtonRelease-3> "_popupTree %X %Y %x %y"
bind $tree <Control-ButtonRelease-3> {_listAllObjsInGhostForFind %X %Y}
bind $tree <Shift-ButtonRelease-3> {_listAllObjsInGhostForMat %X %Y %x %y}
_bindEnterLeave $tree "Hierarchy (MB3\[Shift/Ctrl\]: options)"
scrollbar .f3.y.sb -orient vertical -command {$tree yview}
scrollbar .f3.sb -orient horiz -command {$tree xview}
pack $tree -side left -fill both -expand 1

######################################################################################
# Frame .f4 di destra dei materiali e rendering:
######################################################################################
frame .f4
label .f4.lb -relief ridge -bd 2 -text "Materials"
pack .f4 -side right -fill both -padx 2 -pady 2
pack .f4.lb -fill x
frame .f4.ll
set lbMats [listbox .f4.ll.l -width 24 -yscrollcommand {.f4.ll.s set} \
	-selectmode single -exportselection false -foreground yellow \
	-background grey45 -selectbackground grey55 -selectforeground white]
bind $lbMats <ButtonRelease-1> {}
bind $lbMats <ButtonRelease-3> "tk_popup .matM %X %Y"
_bindEnterLeave $lbMats "Available materials (MB3: options)"
scrollbar .f4.ll.s -command {.f4.ll.l yview} -orient vert
pack .f4.ll -fill both -expand 1 -anchor n
pack .f4.ll.l -side left -fill both -expand 1
# 
# Rendering frame
# 
frame .f4.r
label .f4.r.lb -relief ridge -bd 2 -text "Rendering"
set bgcol grey45
frame .f4.r.im -width 160 -height 170 -bg black -relief sunken -bd 3
set thumb [button .f4.r.im.l -relief ridge -bg black -command _showRenderImage \
	-activebackground black -border 0]
_bindEnterLeave $thumb "Click to display last rendering"
pack .f4.r.lb -fill both -expand 1
place $thumb -in .f4.r.im -relx 0.5 -rely 0.5 -anchor c
_insertCbLb2En .f4.r.wh 4 "Size" render(sizeOn) render(sizew) render(sizeh) \
	"Horizontal resolution" "Vertical resolution"
menu .f4.r.m -tearoff 0
foreach e {0.3 0.6 1.0 1.3 1.6 2.0 2.3 2.6 3.0} {
	.f4.r.m add command -label $e -command "set render(sizem) $e"
}
.f4.r.m entryconfigure 2 -foreground blue
label .f4.r.x -relief ridge -bd 2 -width 3 -textvariable render(sizem)
_bindEnterLeave .f4.r.x "Multiplier"
bind .f4.r.x <1> "tk_popup .f4.r.m %X %Y"
pack .f4.r.x -in .f4.r.wh -side right -padx 2
_insertLbMb .f4.r.rm 16 3 "Rendering method" {1 2 3 4 5 6 7} \
	"Ray-tracing {HLR (white)} {HLR (color)} Scanline \
	{OpenGL (points)} {OpenGL (lines)} {OpenGL (polys)}" render(method)
.f4.r.rm.mb config -text "Ray-tracing"
checkbutton .f4.r.lg -text "Make thumbnail" -var render(thumb) -command _packThumbLabel
checkbutton .f4.r.st -text "Write statistics" -var render(stats)
pack .f4.r.lg .f4.r.st -anchor w
_insert2Butt .f4.r.bt 8 6 "Render" "View log" _render _renderViewLog
_bindEnterLeave .f4.r.bt.b1 "Run Vlight for current scene (Ctrl-r)"
_bindEnterLeave .f4.r.bt.b2 "Show Vlight log"

