proc _verifyLightsList {X Y y} {
	# 
	# attivato da: bind $lbLights <ButtonRelease-3>
	# 
	global lbLights
	.ls delete 0 end
	set sele [$lbLights curselection]
	set iN [$lbLights nearest $y]
	set toRead [lindex [$lbLights get $iN] end]
	set ltype [lindex [$lbLights get $iN] 0]
	set single $toRead
	if {$sele==""} {
		_addLightsEntries $single $ltype $iN
		tk_popup .ls $X $Y; return
	}
	.ls add command -label "Selected lights ([llength $sele]):" -state disabled
	.ls add command -label "On" -command {_lightsOnOff 1}
	.ls add command -label "Off" -command {_lightsOnOff 0}
	.ls add cascade -label "Delete" -menu .ls.d
	set firstType [lindex [$lbLights get [lindex $sele 0]] 0]
	foreach i $sele {
		set lget [$lbLights get $i]
		set type [lindex $lget 0]
		if {$type!="$firstType"} {
			.ls add command -label "Select lights of the same type to edit properties"\
				-state disabled
			.ls add separator
			_addLightsEntries $single $ltype $iN
			tk_popup .ls $X $Y; return
		}
	}
	set isInSele [lsearch $sele $iN]
	if {$isInSele==-1} {set toRead [lindex [$lbLights get [lindex $sele 0]] end]}
	if {$type=="DL"} {set toRead "read $toRead"}
	.ls add command -label "Properties ..." -comm "_${type}_properties_window $toRead"
	.ls add separator
	_addLightsEntries $single $ltype $iN
	tk_popup .ls $X $Y
}

proc _addLightsEntries {single type iN} {
	global sky
	.ls add command -label "Add Directional light ..." -comm _addDirectLightWin
	.ls add checkbutton -label "SkyLight" -var sky(on) -selectc blue -comm _applySkySun
	.ls add checkbutton -label "SunLight" -var sun(on) -selectc blue -comm _applySkySun
	if {$single!=""&&$single!="(declared)"} {
		.ls add separator
		.ls add command -label "$single:" -state disabled
		.ls add command -label "Rename ..." -comm "_renameLightWin $single $type $iN"
		.ls add command -label "Delete" -command "_deleteLight $single $iN"
	}
}

proc _resetLightValues {} {
	global light
	set light(red) 1.000; set light(green) 1.000; set light(blue) 1.000
	set light(rows) 3; set light(cols) 3
	set light(jitter) 0.0; set light(adLevel) 0
	set light(range) {}; set light(decay) 0; set light(lAttr) 3
	set light(glow) {}; set light(mInter) 0
	set light(bulb) 0; set light(blRadius) 0.0
	set light(radius) 7.5; set light(falloff) 15.0; set light(thight) 0.0
	set light(x) 0; set light(y) 0; set light(z) 1
}

proc _AL_properties_window {toRead} {
	if [winfo exists .alp] return
	global light lbLights
	foreach i [$lbLights curselection] {
		set isDec [lindex [$lbLights get $i] end]
		if {$isDec=="(declared)"} {
			tk_messageBox -message "Cannot operate on declared lights.\n\
			Please don't include declared lights in selection."
			return
		}
	}
	toplevel .alp
	wm title .alp "AreaLight properties"
	wm transient .alp .
	wm resizable .alp 0 0
	wm geometry .alp +[winfo pointerx .]+[winfo pointery .]
	bind .alp <Escape> {destroy .alp}
	label .alp.mess -relief ridge -bd 2 -fg blue
 	pack .alp.mess -fill x -expand 1
	_insertLbColor .alp.co .alp 6 "Color" light
	# _insertColorFrame .alp.co .alp Intensity light
	_insertLbEn .alp.rw 18 6 "Rows" light(rows)
	_insertLbEn .alp.cl 14 6 "Columns" light(cols)
	_insertSeparator .alp.s1
	_insertLbEn .alp.ji 14 6 "Jitter" light(jitter)
	_insertLbEn .alp.al 14 6 "Adaptive level" light(adLevel)
	_insertLbEn .alp.rg 14 6 "Range" light(range)
	_insertLbMb .alp.de 14 6 "Decay" "1 2 3 0" \
		"{- Linear} {- Quadratic} {- Cubic} {- none}" light(decay)
	_insertLbMb .alp.la 14 6 "L. Attributes" "1 2 3" \
		"{- Only Shadow} {- Only Specular} {- Shadow and Specular}" light(lAttr)
	label .alp.tg -relief ridge -bd 2 -fg blue -anchor w -justify l
	pack .alp.tg -fill x -expand 1
	_insertApplyDismiss .alp.bts .alp . _apply_AL_properties
	_read_AL_properties $toRead
	grab .alp
}

proc _read_AL_properties {lname} {
	global oText light lbLights
	_resetLightValues
	.alp.mess config -text "$lname"
	set txtI [$oText search "// Light $lname " 1.0 end]
	set mainLine [$oText get "$txtI +1 l" "$txtI +1 l lineend"]
	set values [join [split [string trimright [lindex [split $mainLine (] end] )] ,]]
	set light(rows) [lindex $values 0]
	set light(cols) [lindex $values 1]
	set light(jitter) [lindex $values 2]
	set light(adLevel) [lindex $values 3]
	set line {}
	while {$line!="\]"} {
		set txtI [expr $txtI +1.0]
		set line [$oText get $txtI "$txtI lineend"]
		if [string match {*Intensity *} $line] {
			set light(red) [string trimright [string trimleft [lindex $line 1] '] ,]
			set light(green) [string trimright [lindex $line 2] ,]
			set light(blue) [string trimright [lindex $line 3] ']
			catch {_exaColor $light(red) $light(green) $light(blue)} col
			.alp.co.cc config -bg $col
		}
		if [string match {*Decay *} $line] {set light(decay) [lindex $line end]}
		if [string match {*Range *} $line] {set light(range) [lindex $line end]}
		if [string match {*LightingAttributes *} $line] {
			set light(lAttr) [lindex $line end]
		}
	}
	set ll [$lbLights curselection]
	if {[llength $ll]!=1} {
		foreach i $ll {lappend lgtlist \n[lindex [$lbLights get $i] end]}
		.alp.tg config -text "\tApply to:[join $lgtlist]"
	} else {
		pack forget .alp.tg
	}
}

proc _apply_AL_properties {} {
	global lbLights oText light
	set tmpV [_isInt noNull $light(rows) Rows {}]
	if {$tmpV=="no"} {return} else {set light(rows) $tmpV}
	set tmpV [_isInt noNull $light(cols) Columns {}]
	if {$tmpV=="no"} {return} else {set light(cols) $tmpV}
	set tmpV [_isInt noNull $light(adLevel) {Adaptive level} {}]
	if {$tmpV=="no"} {return} else {set light(adLevel) $tmpV}
	set tmpV [_isFlt noNull $light(jitter) Jitter {(0.0 to turn off)}]
	if {$tmpV=="no"} {return} else {set light(jitter) $tmpV}
	set tmpV [_isFlt okNull $light(range) Range {or null string}]
	if {$tmpV=="no"} {return} else {set light(range) $tmpV}
	_state $oText normal
	set ilist [$lbLights curselection]
	foreach lind $ilist {
		set lname [lindex [$lbLights get $lind] end]
		set nl "AreaLight \[ Plane ($light(rows), $light(cols), $light(jitter),\
			$light(adLevel))"
		set i [$oText search "// Light $lname " 1.0 end]
		set i2 "$i +2l"
		$oText delete "$i +1 l" "$i +1 l lineend"; # attr. principali
		$oText insert "$i +1 l" $nl
		set line {}; set p {set i [expr $i -1.0]}
		set intLine "  Intensity '$light(red), $light(green), $light(blue)'"
		set decLine "  Decay $light(decay)"
		set rngLine "  Range $light(range)"
		set attLine "  LightingAttributes $light(lAttr)"
		while {$line!="\]"} {
			set i [expr $i +1.0]
			set line [$oText get $i "$i lineend"]
			if [string match {*Intensity *} $line] {_delLine $i; eval $p}
			if [string match {*Decay *} $line] {_delLine $i; eval $p}
			if [string match {*Range *} $line] {_delLine $i; eval $p}
			if [string match {*LightingAttributes *} $line] {_delLine $i; eval $p}
			if {$line=="\]"} {
				$oText insert $i2 $intLine\n
				$oText insert $i2 $attLine\n
				if {$light(decay)!=0} {$oText insert $i2 $decLine\n}
				if {$light(range)!=""} {$oText insert $i2 $rngLine\n}
			}
		}
	}
	_state $oText disabled
	destroy .alp
}

proc _PL_properties_window {toRead} {
	if [winfo exists .plp] return
	global light lbLights
	foreach i [$lbLights curselection] {
		set isDec [lindex [$lbLights get $i] end]
		if {$isDec=="(declared)"} {
			tk_messageBox -message "Cannot operate on declared lights.\n\
			Please don't include declared lights in selection."
			return
		}
	}
	toplevel .plp
	wm title .plp "PointLight properties"
	wm transient .plp .
	wm geometry .plp +[winfo pointerx .]+[winfo pointery .]
	wm resizable .plp 0 0
	bind .plp <Escape> {destroy .plp}
	label .plp.mess -relief ridge -bd 2 -fg blue
	pack .plp.mess -fill x -expand 1
	_insertLbColor .plp.cl .plp 6 "Color" light
	# _insertColorFrame .plp.cl .plp Intensity light
	_insertLbEn .plp.rg 14 6 "Range" light(range)
	_insertLbEn .plp.gl 14 6 "Glow" light(glow)
	_insertLbMb .plp.de 14 6 "Decay" "1 2 3 0" \
		"{- Linear} {- Quadratic} {- Cubic} {- none}" light(decay)
	_insertLbMb .plp.la 14 6 "L. Attributes" "1 2 3" \
		"{- Only Shadow} {- Only Specular} {- Shadow and Specular}" light(lAttr)
	_insertLbCb .plp.mi 14 "Media interaction" light(mInter)
	_insertSeparator .plp.s1
	_insertLbCb .plp.bl 14 "Bulb" light(bulb)
	_insertLbEn .plp.blr 14 6 "Bulb radius" light(blRadius)
	label .plp.tg -relief ridge -bd 2 -fg blue -anchor w -justify l
	pack .plp.tg -fill x -expand 1
	_insertApplyDismiss .plp.bts .plp . _apply_PL_properties
	_read_PL_properties $toRead
	grab .plp
}

proc _read_PL_properties {lname} {
	global oText light lbLights
	_resetLightValues
	.plp.mess config -text "$lname"
	set txtI [$oText search "// Light $lname " 1.0 end]
	set mainLine [$oText get "$txtI +1 l" "$txtI +1 l lineend"]
	set type [lindex $mainLine 0]
	if {$type=="PointLight"} {
		set light(pos) [string trim [lindex [split $mainLine \[] end]]
	}
	if {$type=="AreaLight"} {; # e' un Bulb AreaLight
		set s [split $mainLine ,]
		set x [string trim [string trimleft [lindex [lindex $s 0] end] \(]]
		set y [string trim [lindex $s 1]]
		set z [string trim [string trimright [lindex [lindex $s 2] end] \)]]
		set light(pos) ([join "$x $y $z" ", "])
		set light(blRadius) [string trim [string trimright [lindex $s end]] \)]
		set light(bulb) 1
	}
	set line {}
	while {$line!="\]"} {
		set txtI [expr $txtI +1.0]
		set line [$oText get $txtI "$txtI lineend"]
		if [string match {*Intensity *} $line] {
			set light(red) [string trimright [string trimleft [lindex $line 1] '] ,]
			set light(green) [string trimright [lindex $line 2] ,]
			set light(blue) [string trimright [lindex $line 3] ']
			catch {_exaColor $light(red) $light(green) $light(blue)} col
			.plp.cl.cc config -bg $col
		}
		if [string match {*Decay *} $line] {set light(decay) [lindex $line end]}
		if [string match {*Range *} $line] {set light(range) [lindex $line end]}
		if [string match {*Glow *} $line] {set light(glow) [lindex $line end]}
		if [string match {*MediaInteraction*} $line] {set light(mInter) 1}
		if [string match {*LightingAttributes *} $line] {
			set light(lAttr) [lindex $line end]
		}
	}
	set ll [$lbLights curselection]
	if {[llength $ll]!=1} {
		foreach i $ll {lappend lgtlist \n[lindex [$lbLights get $i] end]}
		.plp.tg config -text "\tApply to:[join $lgtlist]"
	} else {
		pack forget .plp.tg
	}
}

proc _apply_PL_properties {} {
	global lbLights oText light
	set tmpV [_isFlt okNull $light(range) Range {or null string}]
	if {$tmpV=="no"} {return} else {set light(range) $tmpV}
	set tmpV [_isFlt okNull $light(glow) Glow {or null string}]
	if {$tmpV=="no"} {return} else {set light(glow) $tmpV}
	if $light(bulb) {
		set tmpV [_isFlt noNull $light(blRadius) {Bulb radius} {}]
		if {$tmpV=="no"} {return} else {set light(blRadius) $tmpV}
	}
	_state $oText normal
	set ilist [$lbLights curselection]
	foreach lind $ilist {
		set lname [lindex [$lbLights get $lind] end]
		if $light(bulb) {; # Bulb AreaLight
			set nl "AreaLight \[ Bulb ( $light(pos), $light(blRadius) )"
		} else {
			set nl "PointLight \[ $light(pos)"
		}
		set i [$oText search "// Light $lname " 1.0 end]
		set i2 "$i +2l"
		$oText delete "$i +1 l" "$i +1 l lineend"; # attr. principali
		$oText insert "$i +1 l" $nl
		set line {}; set p {set i [expr $i -1.0]}
		set intLine "  Intensity '$light(red), $light(green), $light(blue)'"
		set decLine "  Decay $light(decay)"
		set rngLine "  Range $light(range)"
		set gloLine "  Glow $light(glow)"
		set attLine "  LightingAttributes $light(lAttr)"
		set medLine "  MediaInteraction\n"
		while {$line!="\]"} {
			set i [expr $i +1.0]
			set line [$oText get $i "$i lineend"]
			if [string match {*Intensity *} $line] {_delLine $i; eval $p}
			if [string match {*Decay *} $line] {_delLine $i; eval $p}
			if [string match {*Range *} $line] {_delLine $i; eval $p}
			if [string match {*LightingAttributes *} $line] {_delLine $i; eval $p}
			if [string match {*Glow *} $line] {_delLine $i; eval $p}
			if [string match {*MediaInteraction*} $line] {_delLine $i; eval $p}
			if {$line=="\]"} {
				$oText insert $i2 $intLine\n
				$oText insert $i2 $attLine\n
				if {$light(decay)!=0} {$oText insert $i2 $decLine\n}
				if {$light(range)!=""} {$oText insert $i2 $rngLine\n}
				if {$light(glow)!=""} {$oText insert $i2 $gloLine\n}
				if $light(mInter) {$oText insert $i2 $medLine}
			}
		}
	}
	_state $oText disabled
	destroy .plp
}

proc _SL_properties_window {toRead} {
	if [winfo exists .slp] return
	global light lbLights
	foreach i [$lbLights curselection] {
		set isDec [lindex [$lbLights get $i] end]
		if {$isDec=="(declared)"} {
			tk_messageBox -message "Cannot operate on declared lights.\n\
			Please don't include declared lights in selection."
			return
		}
	}
	toplevel .slp
	wm title .slp "SpotLight properties"
	wm transient .slp .
	wm geometry .slp +[winfo pointerx .]+[winfo pointery .]
	wm resizable .slp 0 0
	bind .slp <Escape> {destroy .slp}
	label .slp.mess -relief ridge -bd 2 -fg blue
	pack .slp.mess -fill x -expand 1
	_insertLbColor .slp.cl .slp 6 "Color" light
	# _insertColorFrame .slp.cl .slp Intensity light
	_insertLbEn .slp.rd 14 6 "Radius" light(radius)
	_insertLbEn .slp.fa 14 6 "Falloff" light(falloff)
	_insertLbEn .slp.th 14 6 "Thightness" light(thight)
	_insertSeparator .slp.s0
	_insertLbEn .slp.rg 14 6 "Range" light(range)
	_insertLbMb .slp.de 14 6 "Decay" "1 2 3 0" \
		"{- Linear} {- Quadratic} {- Cubic} {- none}" light(decay)
	_insertLbMb .slp.la 14 6 "L. Attributes" "1 2 3" \
		"{- Only Shadow} {- Only Specular} {- Shadow and Specular}" light(lAttr)
	_insertLbCb .slp.mi 14 "Media interaction" light(mInter)
	_insertSeparator .slp.s1
	_insertLbCb .slp.bl 14 "Bulb" light(bulb)
	_insertLbEn .slp.blr 14 6 "Bulb radius" light(blRadius)
	label .slp.tg -relief ridge -bd 2 -fg blue -anchor w -justify l
	pack .slp.tg -fill x -expand 1
	_insertApplyDismiss .slp.bts .slp . _apply_SL_properties
	_read_SL_properties $toRead
	grab .slp
}

proc _read_SL_properties {lname} {
	global oText light lbLights
	_resetLightValues
	.slp.mess config -text "$lname"
	set txtI [$oText search "// Light $lname " 1.0 end]
	set mainLine [$oText get "$txtI +1 l" "$txtI +1 l lineend"]
	set light(radius) [string trim [string trimright [lindex $mainLine 8] ,]]
	set light(falloff) [string trim [string trimright [lindex $mainLine 9] ,]]
	set light(thight) [string trim [lindex $mainLine end]]
	set line {}
	while {$line!="\]"} {
		set txtI [expr $txtI +1.0]
		set line [$oText get $txtI "$txtI lineend"]
		if [string match {*Intensity *} $line] {
			set light(red) [string trimright [string trimleft [lindex $line 1] '] ,]
			set light(green) [string trimright [lindex $line 2] ,]
			set light(blue) [string trimright [lindex $line 3] ']
			catch {_exaColor $light(red) $light(green) $light(blue)} col
			.slp.cl.cc config -bg $col
		}
		if [string match {*Decay *} $line] {set light(decay) [lindex $line end]}
		if [string match {*Range *} $line] {set light(range) [lindex $line end]}
		if [string match {*Bulb *} $line] {
			set light(bulb) 1
			set light(blRadius) [lindex $line end]
		}
		if [string match {*MediaInteraction*} $line] {set light(mInter) 1}
		if [string match {*LightingAttributes *} $line] {
			set light(lAttr) [lindex $line end]
		}
	}
	set ll [$lbLights curselection]
	if {[llength $ll]!=1} {
		foreach i $ll {lappend lgtlist \n[lindex [$lbLights get $i] end]}
		.slp.tg config -text "\tApply to:[join $lgtlist]"
	} else {
		pack forget .slp.tg
	}
}

proc _apply_SL_properties {} {
	global lbLights oText light
	set tmpV [_isFlt okNull $light(range) Range {or null string}]
	if {$tmpV=="no"} {return} else {set light(range) $tmpV}
	set tmpV [_isFlt noNull $light(radius) Radius {}]
	if {$tmpV=="no"} {return} else {set light(radius) $tmpV}
	if $light(bulb) {
		set tmpV [_isFlt noNull $light(blRadius) {Bulb radius} {}]
		if {$tmpV=="no"} {return} else {set light(blRadius) $tmpV}
	}
	set tmpV [_isFlt noNull $light(falloff) Falloff {}]
	if {$tmpV=="no"} {return} else {set light(falloff) $tmpV}
	set tmpV [_isFlt noNull $light(thight) Thightness {}]
	if {$tmpV=="no"} {return} else {set light(thight) $tmpV}
	_state $oText normal
	set ilist [$lbLights curselection]
	foreach lind $ilist {
		set lname [lindex [$lbLights get $lind] end]
		set i [$oText search "// Light $lname " 1.0 end]
		set i2 "$i +2l"
		set ol [$oText get "$i +1 l" "$i +1 l lineend"]
		set nl [join [lreplace $ol 8 end \
			"$light(radius), $light(falloff), $light(thight)"]]
		$oText delete "$i +1 l" "$i +1 l lineend"; # attr. principali
		$oText insert "$i +1 l" $nl
		set line {}; set p {set i [expr $i -1.0]}
		set intLine "  Intensity '$light(red), $light(green), $light(blue)'"
		set decLine "  Decay $light(decay)"
		set rngLine "  Range $light(range)"
		set blbLine "  Bulb $light(blRadius)"
		set attLine "  LightingAttributes $light(lAttr)"
		set medLine "  MediaInteraction\n"
		while {$line!="\]"} {
			set i [expr $i +1.0]
			set line [$oText get $i "$i lineend"]
			if [string match {*Intensity *} $line] {_delLine $i; eval $p}
			if [string match {*Decay *} $line] {_delLine $i; eval $p}
			if [string match {*Range *} $line] {_delLine $i; eval $p}
			if [string match {*LightingAttributes *} $line] {_delLine $i; eval $p}
			if [string match {*Bulb *} $line] {_delLine $i; eval $p}
			if [string match {*MediaInteraction*} $line] {_delLine $i; eval $p}
			if {$line=="\]"} {
				$oText insert $i2 $intLine\n
				$oText insert $i2 $attLine\n
				if {$light(decay)!=0} {$oText insert $i2 $decLine\n}
				if {$light(bulb)==1} {$oText insert $i2 $blbLine\n}
				if {$light(range)!=""} {$oText insert $i2 $rngLine\n}
				if $light(mInter) {$oText insert $i2 $medLine}
			}
		}
	}
	_state $oText disabled
	destroy .slp
}

proc _DL_properties_window {type name} {
	if [winfo exists .dlp] return
	global light
	toplevel .dlp
	wm title .dlp "Directional light properties"
	wm transient .dlp .
	wm geometry .dlp +[winfo pointerx .]+[winfo pointery .]
	wm resizable .dlp 0 0
	bind .dlp <Escape> {destroy .dlp}
	label .dlp.mess -relief ridge -bd 2 -fg blue -text $name
	pack .dlp.mess -fill x -expand 1
	_insertColorFrame .dlp.cl .dlp Intensity light
	_insertLb3En .dlp.vc 14 5 "Vector" light(x) light(y) light(z) \
		"X direction" "Y direction" "Z direction"
	_insertLbMb .dlp.la 14 3 "L. Attributes" "1 2 3" \
		"{- Only Shadow} {- Only Specular} {- Shadow and Specular}" light(lAttr)
	label .dlp.tg -relief ridge -bd 2 -fg blue -anchor w -justify l
	pack .dlp.tg -fill x -expand 1
	_insertApplyDismiss .dlp.bts .dlp . "_apply_DL_properties $type"
	if {$type!="new"} {
		_read_DL_properties $name
	} else {
		pack forget .dlp.tg
		_resetLightValues
		catch {_exaColor $light(red) $light(green) $light(blue)} col
		.dlp.cl.f1.cc config -bg $col
	}
	grab .dlp
}

proc _read_DL_properties {lname} {
	global oText light lbLights
	_resetLightValues
	.dlp.mess config -text "$lname"
	set txtI [$oText search "// Light $lname " 1.0 end]
	set mainLine [$oText get "$txtI +1 l" "$txtI +1 l lineend"]
	set s [split [lindex $mainLine end] ,]
	set light(x) [string trimleft [lindex $s 0] (]
	set light(y) [lindex $s 1]
	set light(z) [string trimright [lindex $s 2] )]
	set line {}
	while {$line!="\]"} {
		set txtI [expr $txtI +1.0]
		set line [$oText get $txtI "$txtI lineend"]
		if [string match {*Intensity *} $line] {
			set light(red) [string trimright [string trimleft [lindex $line 1] '] ,]
			set light(green) [string trimright [lindex $line 2] ,]
			set light(blue) [string trimright [lindex $line 3] ']
			catch {_exaColor $light(red) $light(green) $light(blue)} col
			.dlp.cl.f1.cc config -bg $col
		}
		if [string match {*LightingAttributes *} $line] {
			set light(lAttr) [lindex $line end]
		}
	}
	set ll [$lbLights curselection]
	if {[llength $ll]!=1} {
		foreach i $ll {lappend lgtlist \n[lindex [$lbLights get $i] end]}
		.dlp.tg config -text "\tApply to:[join $lgtlist]"
	} else {
		pack forget .dlp.tg
	}
}

proc _apply_DL_properties {type} {
	global lightList lbLights oText light
	set tmpV [_isInt noNull $light(x) "X direction" {}]
	if {$tmpV=="no"} {return} else {set light(x) $tmpV}
	set tmpV [_isInt noNull $light(y) "Y direction" {}]
	if {$tmpV=="no"} {return} else {set light(y) $tmpV}
	set tmpV [_isInt noNull $light(z) "Z direction" {}]
	if {$tmpV=="no"} {return} else {set light(z) $tmpV}
	set mainLine "DirectionalLight \[ ($light(x),$light(y),$light(z))\n"
	set intLine "  Intensity '$light(red), $light(green), $light(blue)'\n"
	set attLine "  LightingAttributes $light(lAttr)\n\]\n"
	_state $oText normal
	if {$type!="new"} {
		set ilist [$lbLights curselection]
		foreach lind $ilist {
			set lname [lindex [$lbLights get $lind] end]
			set ii [$oText search "// Light $lname " 1.0 end]
			set ei [$oText search "\]" $ii end]; # il primo che trova!
			$oText delete "$ii +1 l" "$ei +1 l"
			$oText insert "$ii +1 l" "${mainLine}${intLine}${attLine}"
		}
	}
	if {$type=="new"} {
		set lname [.dlp.mess cget -text]
		$oText insert end "\n// Light $lname \n"
		$oText insert end "${mainLine}${intLine}${attLine}"
		set lightList [lappend $lightList $lname]
		$lbLights insert end "DL $lname"
		.f1.lllb config -text "[$lbLights size] lights:"
	}
	_state $oText disabled
	destroy .dlp
}

proc _lightsOnOff {v} {
	global lbLights oText gui
	foreach i [$lbLights curselection] {
		set isDec [lindex [$lbLights get $i] end]
		if {$isDec=="(declared)"} {
			tk_messageBox -message "Cannot operate on declared lights.\n\
			Please don't include declared lights in selection."
			return
		}
	}
	_state $oText normal
	foreach i [$lbLights curselection] {
		lappend llist [lindex [$lbLights get $i] end]
		if {$v==1} {
			$lbLights itemconfigure $i -foreground $gui(activeColor) \
				-selectforeground $gui(activeColor)
		} else {
			$lbLights itemconfigure $i -foreground black -selectforeground black
		}
	}
	foreach l $llist {
		set i [$oText search "// Light $l " 1.0 end]
		set cln [$oText get "$i -1l" "$i -1l lineend"]
		if {$cln=="/*"} {
			$oText delete "$i -1l" $i
			set i2 [$oText search "*/" $i end]; # il primo */ che trova !
			$oText delete $i2 "$i2 +1l"
		}
		if {$v==0} {
			set ni [$oText search "// Light $l " 1.0 end]
			$oText insert $ni "/*\n"
			set ei [$oText search "\]" $ni end]; # il primo /] che trova !
			$oText insert "$ei +1l" "*/\n"
		}
	}
	_state $oText disabled
}

proc _addDirectLightWin {} {
	global done
	if {$done(parsing)==0} return
	toplevel .ad
	wm title .ad "New directional light"
	wm geometry .ad +[winfo pointerx .]+[winfo pointery .]
	wm transient .ad .
	wm resizable .ad 0 0
	bind .ad <Escape> {destroy .ad}
	_insertLbEn .ad.n 14 18 "Name:" {}
	_insertApplyDismiss .ad.bts .ad . {_verifyNewDirectLightName [.ad.n.en get]}
	grab .ad; focus .ad.n.en
}

proc _verifyNewDirectLightName {name} {
	global lightList
	set newname [string trim $name]
	if {$newname==""} return
	set spaced [string match {* *} $newname]
	if $spaced {
		tk_messageBox -message "Spaces not allowed in name"; return
	}
	set listSearch [lsearch $lightList $newname]
	if {$listSearch!=-1} {
		tk_messageBox -message "Name '$newname' already exists!"; return
	}
	destroy .ad
	_DL_properties_window new $name
}

proc _renameLightWin {name type iN} {
	toplevel .rl
	wm title .rl "Rename $name"
	wm geometry .rl +[winfo pointerx .]+[winfo pointery .]
	wm transient .rl .
	wm resizable .rl 0 0
	bind .rl <Escape> {destroy .rl}
	_insertLbEn .rl.n 14 18 "New name:" {}
	_insertApplyDismiss .rl.bts .rl . "_renameLight $name $type $iN"
	.rl.n.en insert end $name
	grab .rl
	focus .rl.n.en
}

proc _renameLight {oldname type li} {
	global oText mess lbLights lightList
	set ti [$oText search "// Light $oldname " 1.0 end]
	set newname [string trim [.rl.n.en get]]
	if {$newname==""} return
	set spaced [string match {* *} $newname]
	if $spaced {
		tk_messageBox -message "Spaces not allowed in name"; return
	}
	set listSearch [lsearch $lightList $newname]
	if {$listSearch!=-1} {
		tk_messageBox -message "Name '$newname' already exists!"; return
	}
	set oldListSearch [lsearch $lightList $oldname]
	set lightList [lreplace $lightList $oldListSearch $oldListSearch $newname]
	_state $oText normal
	$oText delete $ti "$ti +1l"
	$oText insert $ti "// Light $newname \n"
	$lbLights delete $li
	$lbLights insert $li "$type $newname"
	_state $oText disabled
	# 
	# rinomina anche in $mess:
	# 
	_state $mess normal
	$mess tag remove hlight 1.0 end
	set str "Light \[(\]$oldname\[)\]"
	set messIndex [$mess search -regexp $str 1.0]
	if {$messIndex!=""} {
		$mess delete "$messIndex +7c" "$messIndex lineend"
		$mess insert "$messIndex +7c" $newname)
	}
	_state $mess disabled
	destroy .rl
}

proc _deleteLight {name li} {
	global lightList oText mess lbLights
	foreach i [$lbLights curselection] {
		set isDec [lindex [$lbLights get $i] end]
		if {$isDec=="(declared)"} {
			tk_messageBox -message "Cannot operate on declared lights.\n\
			Please don't include declared lights in selection."
			return
		}
	}
	set lsi [lsearch $lightList $name]
	set lightList [lreplace $lightList $lsi $lsi]
	$lbLights delete $li
	set ti [$oText search "// Light $name " 1.0 end]	
	set ti2 [$oText search "\]" $ti end]; # il primo /] che trova !
	set off [$oText get "$ti2 +1l linestart" "$ti2 +1l lineend"]
	if {$off=="*/"} {set ti2 "$ti2 +2l"}
	set mi [$mess search "Light ($name)" 1.0 end]	
	_state $mess normal
	_state $oText normal
	$oText delete "$ti -1l" "$ti2 +1l"
	if {$mi!=""} {$mess delete $mi "$mi +1l"}
	_state $mess disabled
	_state $oText disabled
	.f1.lllb config -text "[$lbLights size] lights:"
}

proc _deleteMultiLights {} {
	global lbLights
	set sele [lsort -decr [$lbLights curselection]]
	if {$sele==""} return
	foreach i $sele {
		set name [lindex [$lbLights get $i] 1]
		_deleteLight $name $i
	}
}
