proc _generalWin {} {
	if [winfo exists .gw] return
	global gen done
	if {$done(parsing)==0} return
	toplevel .gw
	wm title .gw "General options"
	wm geometry .gw +[winfo pointerx .]+[winfo pointery .]
	wm transient .gw .
	wm resizable .gw 0 0
	bind .gw <Escape> {destroy .gw}
	_insertOptFrame2 .gw.bg "Background" gen(bgOn)
	_insertLbColor .gw.bg.c .gw 5 "Color" bg
	_insertOptFrame2 .gw.fg "Fog" gen(fgOn)
	_insertLbEn .gw.fg.di 14 5 "Distance" gen(fgDist)
	_insertLbEn .gw.fg.de 14 5 "Density" gen(fgDens)
	_insertLbColor .gw.fg.c .gw 5 "Color" fg
	_insertOptFrame2 .gw.md "Media" gen(mdOn)
	_insertLbMb .gw.md.sm 18 5 "Scattering model" "1 2 3 4" \
		"Isotropic Rayleight Mie Henvey" gen(mdMod)
	_insertLbEn .gw.md.sa 14 5 "Samples" gen(mdSamp)
	_insertLbEn .gw.md.de 14 5 "Density" gen(mdDens)
	_insertLbEn .gw.md.sc 14 5 "Scattering" gen(mdScat)
	_insertLbEn .gw.md.fi 14 5 "Attenuation" gen(mdFilt)
	_insertLbEn .gw.md.aa 14 5 "Antialiasing" gen(mdAa)
	_insertLbColor .gw.md.c .gw 5 "Color" md
	_insertOptFrame2 .gw.ci "Compute irradiance" gen(irrOn)
	_insertLbMb .gw.ci.gr 18 5 "Init. grid" \
		"8 10 12 14 16 18 20 22 24 26 28 30 32" "" gen(irrGrid)
	_insertOptFrame2 .gw.ph "Photons" gen(phOn)
	_insertLbEn .gw.ph.cn 14 5 "Count" gen(phCnt)
	_insertLbLbs .gw.ph.de 14 5 "Density" gen(phDens) 0.0 1.0 0.01 n
	_insertLbEn .gw.ph.md 14 5 "Media" gen(phMedia)
	_insertApplyDismiss .gw.ad .gw . _applyGeneral
	_readGeneral
}

proc _readGeneral {} {
	global oText gen bg fg md
	# 
	# Occorre inizializzare tutti i valori di default, prima.
	# 
	source src/defaults.tcl
	# 
	# indici di inizio e fine search per le opzioni General:
	# 
	set si [$oText search "// General options " 1.0]
	set ei [$oText search "// Sky & Sun " 1.0]
	if {$si==""||$ei==""} {
		tk_messageBox -message "Linee di riferimento mancanti!.\nNessuna lettura."
		return
	}
	# 
	# Background
	# 
	set i [$oText search "Background '" $si $ei]
	set gen(bgOn) 0
	if {$i!=""} {
		set gen(bgOn) 1
		set sl [$oText get "$i" "$i lineend"]
		set hm [split [lindex $sl 1] ,]
		set bg(red) [string trimleft [lindex $hm 0] ']
		set bg(green) [lindex $hm 1]
		set bg(blue) [string trimright [lindex $hm 2] ']
	}
	catch {_exaColor $bg(red) $bg(green) $bg(blue)} col
	if [winfo exists .gw] {.gw.bg.c.cc config -bg $col}
	# 
	# Fog
	# 
	set i [$oText search "Fog (" $si $ei]
	set gen(fgOn) 0
	if {$i!=""} {
		set gen(fgOn) 1
		set sl [$oText get "$i" "$i lineend"]
		set gen(fgDist) [string trimleft [string trimright [lindex $sl 1] ,] (]
		set gen(fgDens) [string trimright [lindex $sl 2] ,]
		set hm [split [lindex $sl 3] ,]
		set fg(red) [string trimleft [lindex $hm 0] ']
		set fg(green) [lindex $hm 1]
		set fg(blue) [string trimright [string trimright [lindex $hm 2] )] ']
	}
	catch {_exaColor $fg(red) $fg(green) $fg(blue)} col
	if [winfo exists .gw] {.gw.fg.c.cc config -bg $col}
	# 
	# Media
	# 
	set i [$oText search "Media (" $si $ei]
	set gen(mdOn) 0
	if {$i!=""} {
		set gen(mdOn) 1
		set sl [$oText get "$i" "$i lineend"]
		set gen(mdMod) [string trimleft [string trimright [lindex $sl 1] ,] (]
		set gen(mdSamp) [string trimright [lindex $sl 2] ,]
		set gen(mdDens) [string trimright [lindex $sl 3] ,]
		set gen(mdScat) [string trimright [lindex $sl 4] ,]
		set gen(mdFilt) [string trimright [lindex $sl 5] ,]
		set gen(mdAa) [string trimright [lindex $sl 6] ,]
		set hm [split [lindex $sl 7] ,]
		set md(red) [string trimleft [lindex $hm 0] ']
		set md(green) [lindex $hm 1]
		set md(blue) [string trimright [string trimright [lindex $hm 2] )] ']
	}
	catch {_exaColor $md(red) $md(green) $md(blue)} col
	if [winfo exists .gw] {.gw.md.c.cc config -bg $col}
	# 
	# Compute irradiance
	# 
	set i [$oText search "ComputeIrradiance " $si $ei]
	set gen(irrOn) 0
	if {$i!=""} {
		set gen(irrOn) 1
		set sl [$oText get "$i" "$i lineend"]
		set gen(irrGrid) [lindex $sl 1]
	}
	# 
	# Photons
	# 
	set i [$oText search "Photons (" $si $ei]
	set gen(phOn) 0
	if {$i!=""} {
		set gen(phOn) 1
		set sl [$oText get "$i" "$i lineend"]
		set gen(phCnt) [string trimleft [string trimright [lindex $sl 1] ,] (]
		set gen(phDens) [string trimright [lindex $sl 2] ,]
		set gen(phMedia) [string trimright [lindex $sl 3] )]
	}
}

proc _applyGeneral {} {
	global oText gen bg fg md
	# 
	# Verifiche integers/floats
	# 
	if $gen(mdOn) {
		set tmpV [_isInt noNull $gen(mdSamp) {Media samples} {}]
		if {$tmpV=="no"} {return} else {set gen(mdSamp) $tmpV}
		set tmpV [_isInt noNull $gen(mdDens) {Media density} {}]
		if {$tmpV=="no"} {return} else {set gen(mdDens) $tmpV}
		set tmpV [_isFlt noNull $gen(mdScat) {Media scattering} {}]
		if {$tmpV=="no"} {return} else {set gen(mdScat) $tmpV}
		set tmpV [_isFlt noNull $gen(mdFilt) {Media attenuation} {}]
		if {$tmpV=="no"} {return} else {set gen(mdFilt) $tmpV}
		set tmpV [_isInt noNull $gen(mdAa) {Media antialias} {}]
		if {$tmpV=="no"} {return} else {set gen(mdAa) $tmpV}
	}
	if $gen(fgOn) {
		set tmpV [_isFlt noNull $gen(fgDist) {Fog distance} {}]
		if {$tmpV=="no"} {return} else {set gen(fgDist) $tmpV}
		set tmpV [_isFlt noNull $gen(fgDens) {Fog density} {}]
		if {$tmpV=="no"} {return} else {set gen(fgDens) $tmpV}
	}
	set i [$oText search "// General options " 1.0]
	if {$i==""} {
		tk_messageBox -message "Manca la linea di riferimento" -parent .gw
		return
	}
	set i [expr $i +1.0]
	# 
	# cancella tutte le linee dopo "// General options " fino alla prima linea vuota:
	# 
	_state $oText normal
	set line [$oText get $i "$i lineend"]
	while {$line!=""} {
		$oText delete $i "$i +1l linestart"
		set line [$oText get $i "$i lineend"]
	}
	# 
	# Inserisce le linee richieste
	# 
	if $gen(bgOn) {
		$oText insert $i \
			"Background '$bg(red),$bg(green),$bg(blue)'\n"
	}
	if $gen(fgOn) {
		$oText insert $i \
			"Fog ($gen(fgDist), $gen(fgDens), '$fg(red),$fg(green),$fg(blue)')\n"
	}
	if $gen(mdOn) {
		$oText insert $i \
			"Media ($gen(mdMod), $gen(mdSamp),\
			$gen(mdDens), $gen(mdScat), $gen(mdFilt), $gen(mdAa),\
			'$md(red),$md(green),$md(blue)')\n"
	}
	if $gen(irrOn) {
		$oText insert $i \
			"ComputeIrradiance $gen(irrGrid)\n"
	}
	if $gen(phOn) {
		$oText insert $i \
			"Photons ($gen(phCnt), $gen(phDens), $gen(phMedia))\n"
	}
	_state $oText disabled
	grab .
	destroy .gw
}

proc _optionsWin {} {
	if [winfo exists .ow] return
	global opt done
	if {$done(parsing)==0} return
	toplevel .ow
	wm title .ow "Options settings"
	wm geometry .ow +[winfo pointerx .]+[winfo pointery .]
	wm transient .ow .
	wm resizable .ow 0 0
	bind .ow <Escape> {destroy .ow}
	frame .ow.f1; frame .ow.f2
	pack .ow.f1 .ow.f2 -side left -fill both -expand 1 -padx 2 -pady 2
	_insertOptFrame1 .ow.f1.1 ""
	_insertCbLbEn .ow.f1.1.at 5 "Adaptive threshold" opt(adtOn) opt(adtVal) n
	_insertCbLbEn .ow.f1.1.ad 5 "Adaptive depth" opt(addOn) opt(addVal) n
	_insertCbLbEn .ow.f1.1.sb 5 "Shadow bias" opt(shbOn) opt(shbVal) n
	_insertOptFrame1 .ow.f1.2 ""
	_insertCbLbMb .ow.f1.2.bp 5 "Bits per pixel" "24 32" "" opt(bppOn) opt(bppVal) n
	_insertCbLbEn .ow.f1.2.ou 15 "Output image file" opt(outOn) opt(outVal) n
	_insertCbLbMb .ow.f1.2.zc 5 "Z-channel depth" "8 16 24 32 64" "" \
		opt(zchOn) opt(zchVal) n
	_insertCbLb2En .ow.f1.2.gc 5 "Gamma correction" opt(gcOn) opt(gcVal1) opt(gcVal2) \
		"Gamma correction" "Display gamma"
	_insertOptFrame1 .ow.f1.s "Sun"
	_insertCbLbEn .ow.f1.s.sg 5 "Glow" opt(sngOn) opt(sngVal) n
	_insertCbLb3En .ow.f1.s.sr 5 "Light rotation" opt(slrOn) opt(slrV1) opt(slrV2) \
		 opt(slrV3) "X" "Y" "Z"
	_insertOptFrame1 .ow.f1.3 ""
	_insertCbLbEn .ow.f1.3.rl 5 "Max ray level" opt(mrlOn) opt(mrlVal) n
	_insertCbLbEn .ow.f1.3.bs 5 "Max blur sample" opt(mbsOn) opt(mbsVal) n
	_insertCbLbEn .ow.f1.3.bl 5 "Max blur level" opt(mblOn) opt(mblVal) n
	_insertCbLbEn .ow.f1.ss 5 "Soft shadow samples" opt(sssOn) opt(sssVal) n
	_insertCbLbLbs .ow.f1.hg 5 "Henvey Greenstein" opt(hgOn) opt(hgVal) -1.0 1.0 0.01 n
	_insertOptFrame1 .ow.f2.i "Irradiance"
	_insertCbLbLbs .ow.f2.i.ba 5 "Blending area" opt(ibaOn) opt(irrBa) 0.1 2.0 0.01 n
	_insertCbLbMb .ow.f2.i.bl 5 "Bounce level" "1 2 3 4 5 6" "" opt(iblOn) opt(irrBl) n
	_insertCbLbEn .ow.f2.i.md 5 "Max distance" opt(imdOn) opt(irrMd) n
	_insertCbLbLbs .ow.f2.i.me 5 "Max error" opt(imeOn) opt(irrMe) 0.1 1.0 0.01 n
	_insertCbLbEn .ow.f2.i.sa 5 "Samples" opt(ismOn) opt(irrSm) n
	_insertCbLbMb .ow.f2.i.di 5 "Distribution" "1 2 3 4 5 6" \
		"Regular Grid Hammersley Adaptive_u Random N_Rook" opt(idiOn) opt(irrDi) n
	_insertCbLb2En .ow.f2.i.ph 5 "Photons" opt(iphOn) opt(irrPhs) opt(irrPhm) \
		"Samples" "Photons per ray"
	checkbutton .ow.f2.i.li -text "Load cache" -var opt(irrCch)
	pack .ow.f2.i.li -anchor w
	_insertCbLbEn .ow.f2.i.ic 15 "Save cache file" opt(icfOn) opt(icfVal) n
	_insertOptFrame1 .ow.f2.p "Photons"
	checkbutton .ow.f2.p.lp -text "Load map" -var opt(phtCch)
	pack .ow.f2.p.lp -anchor w
	_insertCbLbEn .ow.f2.p.pf 15 "Save map file" opt(pcfOn) opt(pcfVal) n
	_insertCbLb2En .ow.f2.p.gr 5 "Gather range" opt(pgrOn) opt(pgrVal1) opt(pgrVal2) \
		"Minimum" "Maximum"
	_insertApplyDismiss .ow.f2.ok .ow . _applyOptions
	_readOptions
}

proc _readOptions {} {
	global oText opt
	# 
	# Occorre inizializzare tutti i valori di default, prima.
	# 
	source src/defaults.tcl
	# 
	# indici di inizio e fine search per le opzioni Scene options:
	# 
	set si [$oText search "// Scene options " 1.0]
	set ei [$oText search "// Archive files " 1.0]
	if {$si==""||$ei==""} {
		tk_messageBox -message "Linee di riferimento mancanti!.\nNessuna lettura."
		return
	}
	# 
	# Opzioni:
	# 
	set i [$oText search " AdaptiveThreshold " $si $ei]
	set opt(adtOn) 0
	if {$i!=""} {
		set opt(adtOn) 1
		set opt(adtVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " AdaptiveDepth " $si $ei]; set opt(addOn) 0
	if {$i!=""} {
		set opt(addOn) 1
		set opt(addVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " ShadowBias " $si $ei]; set opt(shbOn) 0
	if {$i!=""} {
		set opt(shbOn) 1
		set opt(shbVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " BitsPerPixel " $si $ei]; set opt(bppOn) 0
	if {$i!=""} {
		set opt(bppOn) 1
		set opt(bppVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " OutputTo " $si $ei]; set opt(outOn) 0
	if {$i!=""} {
		set opt(outOn) 1
		set opt(outVal) \
			[string trimright [string trimleft \
				[lindex [$oText get "$i" "$i lineend"] end] \"] \"]
	}
	set i [$oText search " ZChannelDepth " $si $ei]; set opt(zchOn) 0
	if {$i!=""} {
		set opt(zchOn) 1
		set opt(zchVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " GammaCorrection " $si $ei]; set opt(gcOn) 0
	if {$i!=""} {
		set opt(gcOn) 1
		set l [lrange [$oText get "$i" "$i lineend"] 1 end]
		set opt(gcVal1) [string trimright [string trimleft [lindex $l 0] (] ,]
		set opt(gcVal2) [string trimright [string trim [lindex $l 1]] )]
	}
	set i [$oText search " SunGlow " $si $ei]; set opt(sngOn) 0
	if {$i!=""} {
		set opt(sngOn) 1
		set opt(sngVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " SunLightRotation " $si $ei]; set opt(slrOn) 0
	if {$i!=""} {
		set opt(slrOn) 1
		set l [$oText get "$i" "$i lineend"]
		set opt(slrV1) [string trimright [string trimleft [lindex $l 1] (] ,]
		set opt(slrV2) [string trimright [string trim [lindex $l 2]] ,]
		set opt(slrV3) [string trimright [string trim [lindex $l 3]] )]
	}
	set i [$oText search " MaxRayLevel " $si $ei]; set opt(mrlOn) 0
	if {$i!=""} {
		set opt(mrlOn) 1
		set opt(mrlVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " MaxBlurSample " $si $ei]; set opt(mbsOn) 0
	if {$i!=""} {
		set opt(mbsOn) 1
		set opt(mbsVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " MaxBlurLevel " $si $ei]; set opt(mblOn) 0
	if {$i!=""} {
		set opt(mblOn) 1
		set opt(mblVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " SoftShadowSamples " $si $ei]; set opt(sssOn) 0
	if {$i!=""} {
		set opt(sssOn) 1
		set opt(sssVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " HenveyGreenstein " $si $ei]; set opt(hgOn) 0
	if {$i!=""} {
		set opt(hgOn) 1
		set opt(hgVal) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceBlendingArea " $si $ei]; set opt(ibaOn) 0
	if {$i!=""} {
		set opt(ibaOn) 1
		set opt(irrBa) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceBounceLevel " $si $ei]; set opt(iblOn) 0
	if {$i!=""} {
		set opt(iblOn) 1
		set opt(irrBl) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceMaxDistancePixel " $si $ei]; set opt(imdOn) 0
	if {$i!=""} {
		set opt(imdOn) 1
		set opt(irrMd) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceMaxError " $si $ei]; set opt(imeOn) 0
	if {$i!=""} {
		set opt(imeOn) 1
		set opt(irrMe) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceSamples " $si $ei]; set opt(ismOn) 0
	if {$i!=""} {
		set opt(ismOn) 1
		set opt(irrSm) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradianceDistribution " $si $ei]; set opt(idiOn) 0
	if {$i!=""} {
		set opt(idiOn) 1
		set opt(irrDi) [lindex [$oText get "$i" "$i lineend"] end]
	}
	set i [$oText search " IrradiancePhotons " $si $ei]; set opt(iphOn) 0
	if {$i!=""} {
		set opt(iphOn) 1
		set l [$oText get "$i" "$i lineend"]
		set opt(irrPhs) [string trimright [string trimleft [lindex $l 1] (] ,]
		set opt(irrPhm) [string trimright [string trim [lindex $l 2]] )]
	}
	set i [$oText search " LoadIrradianceCache" $si $ei]; set opt(irrCch) 0
	if {$i!=""} {set opt(irrCch) 1}
	set i [$oText search " SaveIrradianceCache " $si $ei]; set opt(icfOn) 0
	if {$i!=""} {
		set opt(icfOn) 1
		set opt(icfVal) \
			[string trimright [string trimleft \
				[lindex [$oText get "$i" "$i lineend"] end] \"] \"]
	}
	set i [$oText search " LoadPhotonMap" $si $ei]; set opt(phtCch) 0
	if {$i!=""} {set opt(phtCch) 1}
	set i [$oText search " SavePhotonMap " $si $ei]; set opt(pcfOn) 0
	if {$i!=""} {
		set opt(pcfOn) 1
		set opt(pcfVal) \
			[string trimright [string trimleft \
				[lindex [$oText get "$i" "$i lineend"] end] \"] \"]
	}
	set i [$oText search " PhotonsGatherRange " $si $ei]; set opt(pgrOn) 0
	if {$i!=""} {
		set opt(pgrOn) 1
		set l [$oText get "$i" "$i lineend"]
		set opt(pgrVal1) [string trimright [string trimleft [lindex $l 1] (] ,]
		set opt(pgrVal2) [string trimright [string trim [lindex $l 2]] )]
	}
}

proc _applyOptions {} {
	global opt oText
	if $opt(adtOn) {
		set tmpV [_isFlt noNull $opt(adtVal) {Adaptive threshold} {}]
		if {$tmpV=="no"} {return} else {set opt(adtVal) $tmpV}
	}
	if $opt(addOn) {
		set tmpV [_isInt noNull $opt(addVal) {Adaptive depth} {}]
		if {$tmpV=="no"} {return} else {set opt(addVal) $tmpV}
	}
	if $opt(shbOn) {
		set tmpV [_isFlt noNull $opt(shbVal) {Shadow bias} {}]
		if {$tmpV=="no"} {return} else {set opt(shbVal) $tmpV}
	}
	if $opt(gcOn) {
		set tmpV [_isFlt noNull $opt(gcVal1) {Gamma values} {}]
		if {$tmpV=="no"} {return} else {set opt(gcVal1) $tmpV}
		set tmpV [_isFlt noNull $opt(gcVal2) {Gamma values} {}]
		if {$tmpV=="no"} {return} else {set opt(gcVal2) $tmpV}
	}
	if $opt(sngOn) {
		set tmpV [_isFlt noNull $opt(sngVal) {Sun glow} {}]
		if {$tmpV=="no"} {return} else {set opt(sngVal) $tmpV}
	}
	if $opt(mrlOn) {
		set tmpV [_isInt noNull $opt(mrlVal) {Max ray level} {}]
		if {$tmpV=="no"} {return} else {set opt(mrlVal) $tmpV}
	}
	if $opt(mbsOn) {
		set tmpV [_isInt noNull $opt(mbsVal) {Max blur sample} {}]
		if {$tmpV=="no"} {return} else {set opt(mbsVal) $tmpV}
	}
	if $opt(mblOn) {
		set tmpV [_isInt noNull $opt(mblVal) {Max blur level} {}]
		if {$tmpV=="no"} {return} else {set opt(mblVal) $tmpV}
	}
	if $opt(sssOn) {
		set tmpV [_isInt noNull $opt(sssVal) {Soft shadow samples} {}]
		if {$tmpV=="no"} {return} else {set opt(sssVal) $tmpV}
	}
	if $opt(imdOn) {
		set tmpV [_isFlt noNull $opt(irrMd) {Irradiance max distance} {}]
		if {$tmpV=="no"} {return} else {set opt(irrMd) $tmpV}
	}
	if $opt(ismOn) {
		set tmpV [_isInt noNull $opt(irrSm) {Irradiance samples} {}]
		if {$tmpV=="no"} {return} else {set opt(irrSm) $tmpV}
	}
	if $opt(iphOn) {
		set tmpV [_isInt noNull $opt(irrPhs) {Irradiance photons values} {}]
		if {$tmpV=="no"} {return} else {set opt(irrPhs) $tmpV}
		set tmpV [_isInt noNull $opt(irrPhm) {Irradiance photons values} {}]
		if {$tmpV=="no"} {return} else {set opt(irrPhm) $tmpV}
	}
	if $opt(pgrOn) {
		set tmpV [_isInt noNull $opt(pgrVal1) {Photons gather values} {}]
		if {$tmpV=="no"} {return} else {set opt(pgrVal1) $tmpV}
		set tmpV [_isInt noNull $opt(pgrVal2) {Photons gather values} {}]
		if {$tmpV=="no"} {return} else {set opt(pgrVal2) $tmpV}
	}
	if $opt(slrOn) {
		set tmpV [_isInt noNull $opt(slrV1) {Sun light rotation values} {}]
		if {$tmpV=="no"} {return} else {set opt(slrV1) $tmpV}
		set tmpV [_isInt noNull $opt(slrV2) {Sun light rotation values} {}]
		if {$tmpV=="no"} {return} else {set opt(slrV2) $tmpV}
		set tmpV [_isInt noNull $opt(slrV3) {Sun light rotation values} {}]
		if {$tmpV=="no"} {return} else {set opt(slrV3) $tmpV}
	}
	if {$opt(outOn)&&$opt(outVal)==""} {
		tk_messageBox -message "Output image file name missing" -parent .ow
		return
	}
	if {$opt(icfOn)&&$opt(icfVal)==""} {
		tk_messageBox -message "Irradiance cache file name missing" -parent .ow
		return
	}
	if {$opt(pcfOn)&&$opt(pcfVal)==""} {
		tk_messageBox -message "Photon map file name missing" -parent .ow
		return
	}
	set i [$oText search "// Scene options " 1.0]
	if {$i==""} {
		tk_messageBox -message "Manca la linea di riferimento" -parent .gw
		return
	}
	set i [expr $i +1.0]
	# 
	# cancella tutte le linee dopo "// Scene options " fino alla prima linea vuota:
	# 
	_state $oText normal
	set line [$oText get $i "$i lineend"]
	while {$line!=""} {
		$oText delete $i "$i +1l linestart"
		set line [$oText get $i "$i lineend"]
	}
	# 
	# Inserisce le linee richieste
	# 
	set oneOpt 0
	$oText insert $i "\]\n"
	if $opt(adtOn) {
		set oneOpt 1; $oText insert $i "  AdaptiveThreshold $opt(adtVal)\n"
	}
	if $opt(addOn) {
		set oneOpt 1; $oText insert $i "  AdaptiveDepth $opt(addVal)\n"
	}
	if $opt(shbOn) {
		set oneOpt 1; $oText insert $i "  ShadowBias $opt(shbVal)\n"
	}
	if $opt(bppOn) {
		set oneOpt 1; $oText insert $i "  BitsPerPixel $opt(bppVal)\n"
	}
	if $opt(outOn) {
		set oneOpt 1; $oText insert $i "  OutputTo \"$opt(outVal)\"\n"
	}
	if $opt(zchOn) {
		set oneOpt 1; $oText insert $i "  ZChannelDepth $opt(zchVal)\n"
	}
	if $opt(gcOn) {
		set oneOpt 1
		$oText insert $i "  GammaCorrection ($opt(gcVal1), $opt(gcVal2))\n"
	}
	if $opt(sngOn) {
		set oneOpt 1
		$oText insert $i "  SunGlow $opt(sngVal)\n"
	}
	if $opt(slrOn) {
		set oneOpt 1
		$oText insert $i "  SunLightRotation ($opt(slrV1), $opt(slrV2), $opt(slrV3))\n"
	}
	if $opt(mrlOn) {
		set oneOpt 1; $oText insert $i "  MaxRayLevel $opt(mrlVal)\n"
	}
	if $opt(mbsOn) {
		set oneOpt 1; $oText insert $i "  MaxBlurSample $opt(mbsVal)\n"
	}
	if $opt(mblOn) {
		set oneOpt 1; $oText insert $i "  MaxBlurLevel $opt(mblVal)\n"
	}
	if $opt(sssOn) {
		set oneOpt 1; $oText insert $i "  SoftShadowSamples $opt(sssVal)\n"
	}
	if $opt(hgOn) {
		set oneOpt 1; $oText insert $i "  HenveyGreenstein $opt(hgVal)\n"
	}
	if $opt(ibaOn) {
		set oneOpt 1; $oText insert $i "  IrradianceBlendingArea $opt(irrBa)\n"
	}
	if $opt(iblOn) {
		set oneOpt 1; $oText insert $i "  IrradianceBounceLevel $opt(irrBl)\n"
	}
	if $opt(imdOn) {
		set oneOpt 1; $oText insert $i "  IrradianceMaxDistancePixel $opt(irrMd)\n"
	}
	if $opt(imeOn) {
		set oneOpt 1; $oText insert $i "  IrradianceMaxError $opt(irrMe)\n"
	}
	if $opt(ismOn) {
		set oneOpt 1; $oText insert $i "  IrradianceSamples $opt(irrSm)\n"
	}
	if $opt(idiOn) {
		set oneOpt 1; $oText insert $i "  IrradianceDistribution $opt(irrDi)\n"
	}
	if $opt(iphOn) {
		set oneOpt 1
		$oText insert $i "  IrradiancePhotons ($opt(irrPhs), $opt(irrPhm))\n"
	}
	if $opt(irrCch) {
		set oneOpt 1; $oText insert $i "  LoadIrradianceCache\n"
	}
	if $opt(icfOn) {
		set oneOpt 1; $oText insert $i "  SaveIrradianceCache $opt(icfVal)\n"
	}
	if $opt(phtCch) {
		set oneOpt 1; $oText insert $i "  LoadPhotonMap\n"
	}
	if $opt(pcfOn) {
		set oneOpt 1; $oText insert $i "  SavePhotonMap $opt(pcfVal)\n"
	}
	if $opt(pgrOn) {
		set oneOpt 1
		$oText insert $i "  PhotonsGatherRange ($opt(pgrVal1), $opt(pgrVal2))\n"
	}
	# 
	# Chiude lo statement Options o cancella la quadra inutile se non ci sono opzioni
	# 
	if $oneOpt {
		$oText insert $i "Options \[\n"
	} else {
		$oText delete $i "$i +1l"
	}
	_state $oText disabled
	destroy .ow
}

proc _skysunWin {} {
	if [winfo exists .ssw] return
	global sky sun done
	if {$done(parsing)==0} return
	toplevel .ssw
	wm title .ssw "Sky & Sun options"
	wm geometry .ssw +[winfo pointerx .]+[winfo pointery .]
	wm transient .ssw .
	wm resizable .ssw 0 0
	bind .ssw <Escape> {destroy .ssw}
	_insertOptFrame2 .ssw.sk "Skylight" sky(on)
	_insertLbEn .ssw.sk.sa 14 5 "Samples" sky(samples)
	_insertLbEn .ssw.sk.br 14 5 "Brightness" sky(bright)
	_insertLbColor .ssw.sk.c .ssw 5 "Color" sky
	_insertOptFrame2 .ssw.sn "Sunlight" sun(on)
	_insertLbMb .ssw.sn.hr 14 5 "Hour" "06 07 08 09 10 11 12 13 14 15 16" "" sun(hour)
	_insertLbLbs .ssw.sn.mn 14 5 "Min" sun(min) 0 59 1 n
	_insertLbEn .ssw.sn.sa 14 5 "Samples" sun(samples)
	_insertLbEn .ssw.sn.br 14 5 "Brightness" sun(bright)
	_insertLbColor .ssw.sn.c .ssw 5 "Color" sun
	_insertApplyDismiss .ssw.ad .ssw . _applySkySun
	_readSkySun
}

proc _readSkySun {} {
	global oText sky sun
	# 
	# Occorre inizializzare tutti i valori di default, prima.
	# 
	source src/defaults.tcl
	# 
	# indici di inizio e fine search per le opzioni Sky Sun:
	# 
	set si [$oText search "// Sky & Sun " 1.0]
	set ei [$oText search "// Camera " 1.0]
	if {$si==""||$ei==""} {
		tk_messageBox -message "Linee di riferimento mancanti!.\nNessuna lettura."
		return
	}
	# 
	# Sky
	# 
	set i [$oText search "SkyLight " $si $ei]
	set sky(on) 0
	if {$i!=""} {
		set sky(on) 1
		set sl [$oText get "$i" "$i lineend"]
		set sky(samples) [string trimright [string trimleft [lindex $sl 1] (] ,]
		set sky(red) [string trimright [string trimleft [lindex $sl 2] '] ,]
		set sky(green) [string trimright [lindex $sl 3] ,]
		set sky(blue) [string trimright [lindex $sl 4] ',]
		set sky(bright) [string trimright [lindex $sl 5] )]
	}
	catch {_exaColor $sky(red) $sky(green) $sky(blue)} col
	if [winfo exists .ssw] {.ssw.sk.c.cc config -bg $col}
	# 
	# Sun
	# 
	set i [$oText search "SunLight " $si $ei]
	set sun(on) 0
	if {$i!=""} {
		set sun(on) 1
		set sl [$oText get "$i" "$i lineend"]
		set hm [split [lindex $sl 1] :]
		set sun(hour) [string trimleft [lindex $hm 0] (]
		set sun(min) [format %.0f [string trimright [lindex $hm 1] ,]]
		set sun(samples) [string trimright [string trimleft [lindex $sl 2] (] ,]
		set sun(bright) [string trimright [lindex $sl 3] ,]
		set sun(red) [string trimright [string trimleft [lindex $sl 4] '] ,]
		set sun(green) [string trimright [lindex $sl 5] ,]
		set sun(blue) [string trimright [lindex $sl 6] ')]
	}
	catch {_exaColor $sun(red) $sun(green) $sun(blue)} col
	if [winfo exists .ssw] {.ssw.sn.c.cc config -bg $col}
}

proc _applySkySun {} {
	global oText sky sun done
	if {$done(parsing)==0} {set sun(on) 0;set sky(on) 0; return}
	# 
	# Verifiche integers/floats
	# 
	if $sun(on) {
		set tmpV [_isInt noNull $sun(samples) {Sun samples} {}]
		if {$tmpV=="no"} {return} else {set sun(samples) $tmpV}
		set tmpV [_isFlt noNull $sun(bright) {Sun brightness} {}]
		if {$tmpV=="no"} {return} else {set sun(bright) $tmpV}
	}
	if $sky(on) {
		set tmpV [_isInt noNull $sky(samples) {Sky samples} {}]
		if {$tmpV=="no"} {return} else {set sky(samples) $tmpV}
		set tmpV [_isFlt noNull $sky(bright) {Sky brightness} {}]
		if {$tmpV=="no"} {return} else {set sky(bright) $tmpV}
	}
	set i [$oText search "// Sky & Sun " 1.0]
	if {$i==""} {
		tk_messageBox -message "Manca la linea di riferimento" -parent .ssw
		return
	}
	set i [expr $i +1.0]
	# 
	# cancella tutte le linee dopo "// Sky & Sun " fino alla prima linea vuota:
	# 
	_state $oText normal
	set line [$oText get $i "$i lineend"]
	while {$line!=""} {
		$oText delete $i "$i +1l linestart"
		set line [$oText get $i "$i lineend"]
	}
	# 
	# Inserisce le linee richieste
	# 
	if $sun(on) {
		set sm $sun(min)
		if {$sm<10} {set sm "0$sm"}
		$oText insert $i "SunLight ($sun(hour):$sm, $sun(samples), $sun(bright),\
		'$sun(red), $sun(green), $sun(blue)')\n"
	}
	if $sky(on) {
		$oText insert $i "SkyLight ($sky(samples),\
		'$sky(red), $sky(green), $sky(blue)', $sky(bright))\n"
	}
	_state $oText disabled
	grab .
	destroy .ssw
}

