proc _parseMesh {type line} {
	global inputFile oText lbShapes transfList mess lbDecs messLb stats gui outputFile
	_openGeoFile
	if {$type=="prm"} {
		set lname [lindex [join [lindex [split $line //] end]] end]
		_mess cyan "Toplevel mesh";_mess {} " ($lname):\n\t"
	}
	if {$type=="decl"} {
		set lname [lindex [lindex [split $line \{] 0] 1]
		_mess grey85 "declared mesh ($lname) in geo file:\n\t"
		_addObjToList $lbDecs "$lname"
	}
	_refresh
	set addOper 0
	set braceCnt 1
	set transfList ""
	set tri 0
	incr stats(pri)
	puts $outputFile(geoId) "Declare $lname =\nSolid \["
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				if {$type=="prm"} {
					$oText insert end "\n// Toplevel refObject $lname \n$lname\n\[\n"
				}
				if {$transfList!=""} {
					puts $outputFile(geoId) ""
					foreach s $transfList {puts $outputFile(geoId) "  $s"}
				}
				puts $outputFile(geoId) "\]\n"
				if {$type=="prm"} {
					_writeMaterial $lname
					$oText insert end "\]\n"
					_addObjToList $lbShapes "$lname"
				}
				close $outputFile(geoId)
				$oText insert end "\n// Definition of '$lname' in geo file\n"
				set transfList ""
				_mess pink "$tri triangles, geometry included in .geo file.\n"
				set stats(tri) [expr $stats(tri) + $tri]
				return
			}
		}
		if [string match {*smooth_triangle \{} $line] {
			for {set n 1} {$n<=3} {incr n} {
				gets $inputFile(openId) line
				set v$n [string trimleft [join [lindex [split $line >] 0]] <]
				set n$n [string trimleft [join [lindex [split $line >] 1]] ", <"]
			}
			if $addOper {puts $outputFile(geoId) +}
			puts $outputFile(geoId) "  Shape \[TriangularPatch (($v1),($n1),($v2),"
			puts -nonewline $outputFile(geoId) "    ($n2),($v3),($n3))\]"
			set addOper 1
			incr braceCnt -1
			incr tri
			if $gui(tcounter) {set messLb "TriPatches: $tri"; update}
		}
		_parseTransformations $line
	}	
}

proc _parseMesh2 {type line} {
	global inputFile oText lbShapes transfList mess lbDecs messLb stats gui outputFile
	_openGeoFile
	if {$type=="prm"} {
		set lname [lindex [join [lindex [split $line //] end]] end]
		_mess cyan "Toplevel mesh";_mess {} " ($lname):\n\t"
	}
	if {$type=="decl"} {
		set lname [lindex [lindex [split $line \{] 0] 1]
		_mess grey85 "declared mesh ($lname):\n\t"
		_addObjToList $lbDecs "$lname"
	}
	_refresh
	set addOper 0
	set braceCnt 1
	set transfList ""
	set tri 0
	set vlist {}; set nlist {}
	set fIlist {}; set nIlist {}
	incr stats(pri)
	puts $outputFile(geoId) "Declare $lname =\nSolid \["
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				for {set n 0} {$n<[llength $fIlist]} {incr n} {
					set v1 [lindex $vlist [lindex [lindex $fIlist $n] 0]]
					set v2 [lindex $vlist [lindex [lindex $fIlist $n] 1]]
					set v3 [lindex $vlist [lindex [lindex $fIlist $n] 2]]
					set n1 [lindex $nlist [lindex [lindex $nIlist $n] 0]]
					set n2 [lindex $nlist [lindex [lindex $nIlist $n] 1]]
					set n3 [lindex $nlist [lindex [lindex $nIlist $n] 2]]
					if $addOper {puts $outputFile(geoId) +}
					puts $outputFile(geoId) "  Shape \[TriangularPatch ($v1,$n1,$v2,"
					puts -nonewline $outputFile(geoId) "    $n2, $v3, $n3)\]"
					set addOper 1
					incr tri
				}
				if {$type=="prm"} {
					$oText insert end "\n// Toplevel refObject $lname \n$lname\n\[\n"
				}
				if {$transfList!=""} {
					puts $outputFile(geoId) ""
					foreach s $transfList {puts $outputFile(geoId) "  $s"}
				}
				puts $outputFile(geoId) "\]\n"
				if {$type=="prm"} {
					_writeMaterial $lname
					$oText insert end "\]\n"
					_addObjToList $lbShapes "$lname"
				}
				$oText insert end "\n// Definition of '$lname' in geo file\n"
				close $outputFile(geoId)
				set transfList ""
				_mess pink "$tri triangles, geometry included in .geo file.\n"
				set stats(tri) [expr $stats(tri) + $tri]
				return
			}
		}
		if [string match {*vertex_vectors \{*} $line] {
			gets $inputFile(openId) line
			set nOfVtx [string trim [lindex [split $line ,] 0]]
			for {set n 1} {$n<=$nOfVtx} {incr n} {
				gets $inputFile(openId) line
				set v ([string trimleft [join [lindex [split $line >] 0]] <])
				lappend vlist $v
			}
		}
		if [string match {*normal_vectors \{*} $line] {
			gets $inputFile(openId) line
			set nOfNrm [string trim [lindex [split $line ,] 0]]
			for {set n 1} {$n<=$nOfNrm} {incr n} {
				gets $inputFile(openId) line
				set i ([string trimleft [join [lindex [split $line >] 0]] <])
				lappend nlist $i
			}
		}
		if [string match {*face_indices \{*} $line] {
			gets $inputFile(openId) line
			set nOfFi [string trim [lindex [split $line ,] 0]]
			for {set n 1} {$n<=$nOfFi} {incr n} {
				gets $inputFile(openId) line
				set i [split [string trimleft [join [lindex [split $line >] 0]] <] ,]
				lappend fIlist [join $i]
			}
		}
		if [string match {*normal_indices \{*} $line] {
			gets $inputFile(openId) line
			set nOfNi [string trim [lindex [split $line ,] 0]]
			for {set n 1} {$n<=$nOfNi} {incr n} {
				gets $inputFile(openId) line
				set i [split [string trimleft [join [lindex [split $line >] 0]] <] ,]
				lappend nIlist [join $i]
			}
		}
		_parseTransformations $line
	}	
}

proc _parseBPatch1sheetDec {name line} {
	# 
	# caso di bpatch 1sheet declared
	# 
	global inputFile oText lbDecs transfList stats
	_mess grey85 "declared bpatch ($name)\n"
	_mess grey85 "\t----- (1 patch)\n"
	_addObjToList $lbDecs "$name"
	_parseBPatch dec {} $line
	gets $inputFile(openId) line; # graffa chiusa
	set braceCnt 1
	set transfList ""
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				set transfList ""
				$oText insert end "\]\n"
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseBPatch {type oper line} {
	# 
	# Senza while di ricerca delle transfs.
	# Parsing della singola bpatch, $line e' sempre la prima: 'bicubic_patch ...'
	# Fa il gets da: 'bicubic_patch { ... '
	# a:             '}'
	global inputFile oText messLb stats uvSteps gui
	set sep1 ""; set sep2 "  "
	if {$type=="csg"} {set sep1 "  "; set sep2 "    "}
	$oText insert end "\n${sep1}Shape \[ BicubicPatch (BEZIER, $uvSteps, $uvSteps,\n"
	for {set n 1} {$n<=3} {incr n} {
		gets $inputFile(openId) line
		set s1 [split $line >]
		set v1 ([string trimleft [join [lindex $s1 0]] ", <"])
		set v2 ([string trimleft [join [lindex $s1 1]] ", <"])
		set v3 ([string trimleft [join [lindex $s1 2]] ", <"])
		set v4 ([string trimleft [join [lindex $s1 3]] ", <"])
		$oText insert end "${sep2}$v1, $v2, $v3, $v4,\n"
	}
	gets $inputFile(openId) line
	set s1 [split $line >]
	set v1 ([string trimleft [join [lindex $s1 0]] ", <"])
	set v2 ([string trimleft [join [lindex $s1 1]] ", <"])
	set v3 ([string trimleft [join [lindex $s1 2]] ", <"])
	set v4 ([string trimleft [join [lindex $s1 3]] ", <"])
	$oText insert end "${sep2}$v1, $v2, $v3, $v4 )\n"
	if {$type=="csg"} {$oText insert end "${sep1}\] $oper"}
	incr stats(bpt)
	if $gui(tcounter) {set messLb "BPatches: $stats(bpt)"; update}
	gets $inputFile(openId) line; # graffa chiusa
}

proc _putBpatchInGeo {tline} {
	global oText outputFile
	set si [$oText search -backw $tline end]
	if {[lindex $tline 0]=="//"} {; # Toplevel
		set lname [lindex $tline 3]
		set pbDef "Declare $lname =\n[$oText get "$si +1l" end]"
	} else {
		set lname [lindex $tline 1]
		set pbDef [$oText get $si end]
	}
	$oText delete $si end
	_openGeoFile
	puts -nonewline $outputFile(geoId) $pbDef
	close $outputFile(geoId)
	if {[lindex $tline 0]=="//"} {; # Toplevel
		$oText insert end "\n// Definition of '$lname' in geo file\n"
		$oText insert end "\n// Toplevel refObject $lname \n"
		$oText insert end "$lname\n"
		$oText insert end "\[\n"
		_writeMaterial $lname
		$oText insert end "\]\n"
	} else {
		$oText insert end "\n// Definition of '$lname' in geo file\n"
	}
}

