# 
# Parsing principale del file POV:
# 
proc _parseInputFile {} {
	global gui inputFile done mess oText lbLights lbShapes lbDecs thumb \
		objList messLb stats skippedList allObjList stopParsing userIncludes
	# 
	# Apre il file di input in lettura, se c`e`:
	# 
	set stopParsing 0
	if {$inputFile(name)==""} return
	if [catch {open $inputFile(dir)/$inputFile(name) r} inputFile(openId)] {
		tk_messageBox -message "Cannot open $inputFile(name):\n$inputFile(openId)"
		return
	}
	fconfigure $inputFile(openId) -blocking 0
	set vibCntrl 0; if $gui(vibFrame) {set vibCntrl 1}
	set mesCntrl 1; if !$gui(messFrame) {set mesCntrl 0}
	set gui(vibFrame) 0
	set gui(messFrame) 1
	_vibFrame
	_messFrame
	_state $oText normal
	_state $mess normal
	# 
	# Reset:
	# 
	_clearScene
	# 
	# Prime linee del file:
	# 
	catch {_parsePovFileInfo} infoFile
	if {$infoFile=="notMoray"} {
		close $inputFile(openId)
		_mess {} "Incorrect input file format.\nExit.\n"
		_refresh
		return
	}
	_cursor watch
	_mess {} "---------------------------------------------------------\n"
	_mess {} "Converting scene ...\n\n"
	# 
	# Parsing principale:
	# 
	while {[gets $inputFile(openId) line]>=0} {
		if $stopParsing {# _stopParse (Ctrl-h)
			close $inputFile(openId)
			_clearScene
			set stopParsing 0
			_mess {} "Aborted\n"
			_cursor {}
			_state $mess disabled
			_state $oText disabled
			_refresh
			return
		}
		if {$line=="// Scene Includes"} {set userIncludes 1}
		if {$line=="// End Scene Includes"} {set userIncludes 0}
		if [string match {background*color*<*>*} $line] {_parseBGcolor $line}
		if [string match {camera \{*} $line]            {_parseCamera}
		if [string match {light_source \{*} $line]    {_parseLight prm $line; _refresh}
		# 
		# Primo livello (nessuno spazio a inizio riga)
		# 
		if [string match {text \{*} $line] {
			set name [lindex [lindex [split $line \{] end] end]
			_parseUnsupported Text $name
		}
		if [string match {blob \{*} $line] {
			set name [lindex [lindex [split $line \{] end] end]
			_parseNotImplemented Blob $name
		}
		if [string match {cylinder \{*} $line] {_parseCylinder prm $line; _refresh}
		if [string match {cone \{*} $line]     {_parseCone prm $line; _refresh}
		if [string match {superellipsoid \{*} $line] \
			                                   {_parseSuperq prm $line; _refresh}
		if [string match {disc \{*} $line]     {_parseRing $line; _refresh}
		if [string match {torus \{*} $line]    {_parseTorus prm $line; _refresh}
		if [string match {sphere \{*} $line]   {_parseSphere prm $line; _refresh}
		if [string match {box \{*} $line]      {_parseBox prm $line; _refresh}
		if [string match {lathe \{*} $line]    {_parseLathe prm $line; _refresh}
		if [string match {plane \{*} $line]    {_parsePlane prm $line; _refresh}
		if [string match {object \{*} $line]   {_parseObject {} {} $line; _refresh}
		if [string match {union \{*} $line]        {_parseCSG orig + $line; _refresh}
		if [string match {intersection \{*} $line] {_parseCSG orig * $line; _refresh}
		if [string match {difference \{*} $line]   {_parseCSG orig - $line; _refresh}
		if [string match {merge \{*} $line]        {_parseCSG orig ^ $line; _refresh}
		if [string match {\#include *} $line]      {_parseIncludeFile $line}
		if [string match {\#declare *=*\{*} $line] {_parseDeclare $line; _refresh}
		if [string match {mesh \{*} $line]    {_parseMesh prm $line}
		if [string match {mesh2 \{*} $line]   {_parseMesh2 prm $line}
		if [string match {prism \{*} $line]   {_parsePrism prm $line; _refresh}
	}
	close $inputFile(openId)
	_mess {} "---------------------------------------------------------\n"
	if $done(camera) {
		_read_cameraSettings
	} else {
		set goi [$oText search "// General options" 1.0]
		# 
		# Cerca la prima linea vuota dopo '// General options':
		# 
		while {[$oText get $goi "$goi lineend"]!=""} {set goi [expr $goi +1.0]}
		$oText insert "$goi +1l" "// Camera \n"
		_mess orange "No camera statement found!\n\n"
	}
	_mess {} "Scene converted.\n"
	set ms1 ""; set ms2 ""
	if {$stats(tri)!=0} {set ms1 "Triangles: $stats(tri)"}
	if {$stats(bpt)!=0} {set ms2 "BPatches: $stats(bpt)"}
	if {$stats(tri)!=0&&$stats(bpt)!=0} {
		set messLb "$ms1 - $ms2"
	} else {
		set messLb "${ms1}$ms2"
	}
	_mess {} "  $stats(tri) triangles\n  $stats(bpt) bpatches\n"
	_mess {} "  $stats(pri) primitives\n"
	_mess {} "  $stats(ins) instances\n"
	_mess {} "  $stats(skp) skipped reference objs ([llength $skippedList] total).\n\n"
	_buildTree 1
	_cursor {}
	$thumb config -image {}
	$thumb config -bd 0
	.f1.lllb config -text "[$lbLights size] lights:"
	.f1.shlb config -text "[$lbShapes size] toplevel items:"
	.f1.delb config -text "[$lbDecs size] declared items:"
	$oText insert end \n
	_state $mess disabled
	_state $oText disabled
	if $vibCntrl {set gui(vibFrame) 1; _vibFrame}
	if !$mesCntrl {set gui(messFrame) 0; _messFrame}
	.f4.r.bt.b1 config -state normal; # Render e ViewLog buttons
	.f4.r.bt.b2 config -state normal
	_refresh
	wm title . "$gui(appTitle) - Editing output of: $inputFile(name)"
	.f1.h config -text "Conversion done"
	if {$skippedList!=""&&$gui(listSkip)} _listSkipped
	set done(parsing) 1
}

proc _stopParse {} {
	global stopParsing
	set stopParsing 1
}

proc _parseBGcolor {line} {
	global mess oText bg
	catch {_vectorColor $line} bgcol
	set goi [$oText search "// General options " 1.0]
	$oText insert "$goi +1l" "Background $bgcol\n"
	set bgc [split $bgcol ,]
	set bg(red) [string trimleft [lindex $bgc 0] ']
	set bg(green) [lindex $bgc 1]
	set bg(blue) [string trimright [lindex $bgc 2] ']
	_mess bisque "Background color\n"
}

proc _parseCamera {} {
	global inputFile done oText mess spotLookAt
	# 
	# Possono esserci piu` `camera` dichiarate, si suppone che quella attiva sia solo
	# la prima
	# 
	set aper {}; set bsamp {}
	while {[gets $inputFile(openId) line]>=0} {
		# 
		# alla prima graffa chiusa che trova, a partire dallo statement `camera`, 
		# scrive ed esce (non dovrebbero esserci altre braces in `camera`, evitiamo
		# il controllo):
		# 
		if [string match "*\}*" $line] {
			if {$cameraIsSpot==0&&$done(camera)==0} {
				_mess bisque "Camera\n"
				$oText insert end "// Camera \n"
				$oText insert end "Camera \[\n"
				$oText insert end "  $loc, $lka, $upa\n  FieldOfView $angV\n"
				_setImageDim
				$oText insert end "\n  FrameAspectRatio [expr $asr * -1]"
				if {$aper!=""} {
					$oText insert end "\n  DepthOfField ($aper,0,$bsamp)"
				}
				$oText insert end "\n\]\n"
				set done(camera) 1
			}
			return
		}
		if [string match "*location*<*>*" $line] {catch {_vector $line} loc}
		if [string match "*look_at*<*>" $line] {
			catch {_vector $line} lka
			set cameraIsSpot 0
		}
		# 
		# E' una camera di spotLight:
		# 
		if [string match "*look_at*<*>*//*Following*" $line] {
			set spotCamName [lindex $line end]
			catch {_vector $line} pta
			set spotLookAt($spotCamName) $pta
			set cameraIsSpot 1
		}
		if [string match "*up*<*>*" $line] {catch {_vector $line} upa}
		# per convertire il sistema cartesiano in left-handed occorre rendere
		# negativo il FrameAspectRatio, assumo che l'aspect ratio sia il vettore right:
		if [string match "*right*<*>*" $line] {
			catch {_vector $line} rgt
			set asr [string trimleft [lindex [split $rgt ,] 0] \(]
		}
		if [string match "*angle*//*Vertical*" $line] {set angV [lindex $line end]}
		if [string match "*aperture*" $line] {set aper [lindex $line end]}
		if [string match "*blur_samples*" $line] {set bsamp [lindex $line end]}
	}
}

proc _parseLight {org line} {
	global inputFile mess oText lbLights spotLookAt lightList lbDecs
	if {$org=="prm"} {; # da inizio riga, parsing principale
		set lname [lindex [join [lindex [split $line //] end]] end]
	} else {; # da _parseDeclare
		set lname [lindex [lindex [split $line \{] 0] 1]
		_addObjToList $lbDecs "$lname"
	}
	_mess bisque "Light"; _mess {} " ($lname)\n"
	set braceCnt 1
	set type PointLight ; # inizializza $type
	set pos "(0, 0, 0)" ; # rimane cosi` per point/spotLight in assenza di transform.
	set stack(sca) ""; set stack(rot) ""; set stack(tra) ""
	set fdp ""; set sdl ""
	# 
	# assegnera' comunque un jitter 0.0 ed adaptiveLevel 0 alle arealights:
	# 
	set jit 0.0; set adl 0
	while {[gets $inputFile(openId) line]>=0} {
		if [string match "*\{*" $line] {incr braceCnt}
		# 
		# scrive ed esce (controlla eventuali braces interne (es. photons))
		# all`ultima graffa:
		# 
		if [string match "*\}*" $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				# 
				# per point/spotl. occorre fornire 'position' utilizzando stack(tra):
				# 
				if {$stack(tra)!=""} {catch {_lightPosition $stack(tra)} pos}
				if {$type=="SpotLight"} {set opt "$pos, $opt"}
				if {$type=="PointLight"} {set opt "$pos"}
				if {$type=="AreaLight"} {set opt "Plane ($rows, $cols, $jit, $adl)"}
				if {$org=="dec"} {$oText insert end "\nShape \["}
				$oText insert end "\n// Light $lname \n"
				$oText insert end "$type \[ [join $opt]"
				$oText insert end "\n  Intensity $col"
				if {$fdp!=""} {$oText insert end "\n  Range $fdp"}
				if {$sdl!=""} {$oText insert end "\n  $sdl"}
				if {$type=="AreaLight"} { ; # Transformations solo per AreaLight
					if {$stack(sca)!=""} {
						foreach s $stack(sca) {$oText insert end "\n  Scale $s"}
					}
					if {$stack(rot)!=""} {
						foreach s $stack(rot) {$oText insert end "\n  Rotate $s"}
					}
					if {$stack(tra)!=""} {
						foreach s $stack(tra) {$oText insert end "\n  Translate $s"}
					}
				}
				if {$org=="dec"} {$oText insert end "\n\]"}
				$oText insert end "\n\]\n"
				regexp {[ASP]} $type match
				if {$org=="prm"} {$lbLights insert end "${match}L $lname"}
				if {$org=="dec"} {$lbLights insert end "${match}L $lname (declared)"}
				lappend lightList $lname
				return
			}
		}
		# 
		# cerca le keywords necessarie:
		# 
		if [string match "*area_light*<*>*" $line] {
			set type AreaLight
			# 
			# Moray produce area_light di dimensione 2x2 (x-y), VL 1x1
			# quindi di default ne raddoppiamo la dimensione xy:
			# 
			lappend stack(sca) "(2, 2, 1)"
			set line [split $line ,]
			set rows [join [lindex $line 6]]; set cols [join [lindex $line 7]]
		}
		# 
		# jitter puo' esserci o meno nel pov (solo per arealight)
		# 
		if [string match "*jitter*" $line] {set jit 0.15}
		# 
		# adaptive c'e' sempre nel pov, anche adaptive 0 (solo per arealight)
		# 
		if [string match "*adaptive*" $line] {set adl [lindex $line end]}
		if [string match "*spotlight*" $line] {
			set type SpotLight
			# spotLookAt viene creato in _parseCamera dalla riga look_at di SpotCam
			# E` necessario perche` spotlight di Moray usa le trasformazioni per
			# modificare position & point_at della luce, mentre in VL non si puo`.
			# NON BISOGNA CANCELLARE LE SPOTCAMs in Moray !!
			set sptLka [array exists spotLookAt]
			if {$sptLka && [lsearch [array names spotLookAt] $lname]!=-1} {
				set pta $spotLookAt($lname)
			} else {
				set pta "(0, 0, 0)"
				tk_messageBox -message "No SpotCam for SpotLight\n'$lname'\
					\nPoint_at set to (0, 0, 0)"
			}
		}
		if [string match "*falloff*" $line] {set flf [lindex $line 1]}
		if [string match "*radius*" $line] {set rad [lindex $line 1]}
		if [string match "*tightness*" $line] {; # e` l`ultimo parametro di spotlight
			set tgt [lindex $line 1]
			set opt "$pta, $rad, $flf, $tgt"
		}
		if [string match "*scale*" $line] {
			catch {_transfStackScale $line} sca
			lappend stack(sca) $sca
		}
		if [string match "*rotate*" $line] {
			catch {_transfStackRotate $line} rot
			lappend stack(rot) $rot
		}
		if [string match "*translate*" $line] {
			catch {_transfStackTranslate $line} tra
			lappend stack(tra) $tra
		}
		# 
		# cerca le keywords accessorie:
		# 
		if [string match "*color*rgb*<*>*" $line] {catch {_vectorColor $line} col}
		if [string match "*fade_power*" $line] {set fdp [lindex $line end]}
		if [string match "*shadowless*" $line] {set sdl "LightingAttributes 2"}
		# e' dubbio se corrispondano media_attenuation con MediaInteraction:
		# if [string match "*media_attenuation*on*" $line] {set mda "MediaInteraction"}
	}
}

proc _parseCSG {type oper line} {
	# 
	# Arriva la linea con {csg_operation \{*} ...
	# dal _parseInputFile (CSG originario) ...
	# o la linea con {\#declare name = csg_operation \{*}
	# dal _parseDeclare (CSG declared)
	#
	global inputFile mess oText lbShapes transfList trashNameList items lbDecs currObj\
		stats skippedList
	if {$type=="orig"} {
		set lname [lindex [join [lindex [split $line //] end]] end]
		_mess cyan "Toplevel CSG";_mess {} " ($lname):\n"
		set olabel "Toplevel CSG"
		$oText insert end "\n// $olabel $lname \nSolid \["
		_addObjToList $lbShapes "$lname"
	}
	if {$type=="decl"} {
		set lname [lindex [lindex [split $line \{] 0] 1]
		_mess grey85 "declared CSG ($lname):\n"
		set olabel "CSG"
		$oText insert end "\nSolid \["
		_addObjToList $lbDecs "$lname"
	}
	set items 0
	set braceCnt 1
	set transfList ""
	set currCSGtype ""
	# 
	# fare 'eval $c' tutte le volte che aggiunge con certezza un item (e.g _parseBox)
	# 1- Toglie una brace sicuramente in piu` dato che i vari _parse`Prim`
	#    (string match qui sotto) ne tolgono una a questo while.
	# 2- Cancella una riga vuota nel txt.
	# 3- Aggiunge l'operator.
	# 
	set c {incr braceCnt -1; $oText delete "end -1 lines" end
		$oText insert end " $oper"; incr items}
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*difference \{*} $line] {; # RndDiscs (casi B, D ed F)
			set currCSGtype "Rounded disc"
			# 
			# _parseRndDisc1 ritorna con transfs || 'bounded_by' || 'material' || '\}'
			# 
			set line [_parseRndDisc $line]; eval $c; incr braceCnt
		}
		if [string match {*cylinder \{*scale*} $line] {; # RndDiscs (casi A, C ed E)
			set currCSGtype "Rounded disc"
			set line [_parseRndDisc2 $line]; eval $c; incr braceCnt
		}
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				# 
				# Se $items==0 non ci sono componenti validi nel CSG, puliamo il oText
				# da Solid ed eventuali Declare ed usciamo:
				# 
				if {$items==0} {
					$oText delete "end -2 lines" end
					set cl cyan
					if {$type=="decl"} {
						lappend trashNameList $lname
						$lbDecs delete end
						set cl grey85
					}
					if {$type=="orig"} {
						$lbShapes delete end
					}
					_mess $cl "\t----- Empty CSG. Skipped\n"
					return
				}
				# 
				# finiti i componenti del CSG, toglie l'ultimo operator dal txt:
				# 
				$oText delete "end -2 chars" end
				$oText insert end "\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				if {$type=="orig"} {_writeMaterial $lname}
				$oText insert end "\]\n"
				global $currObj
				if {[set $currObj]==""} {; # bpatch/rndDisc/rndCube
					if {$currCSGtype==""} {
						set msg "\t----- ($items patches) in geo file\n"
					} else {
						set msg "\t----- ($currCSGtype)\n"
					}
					if {$type=="orig"} {
						_mess cyan $msg
						_putBpatchInGeo "// Toplevel CSG $lname "
					}
					if {$type=="decl"} {
						_mess grey85 $msg
						_putBpatchInGeo "Declare $lname ="
					}
					incr stats(pri)
				} else {
					if {$type=="orig"} {_mess cyan   "\t----- ($items elements)\n"}
					if {$type=="decl"} {_mess grey85 "\t----- ($items elements)\n"}
				}
				# _puts "$type $currObj ([set $currObj])"
				set transfList ""
				set items 0
				return
			}
		}
		if [string match {*cylinder \{*} $line]   {_parseCylinder csg $line; eval $c}
		if [string match {*cone \{*} $line]       {_parseCone csg $line; eval $c}
		if [string match {*superellipsoid \{*} $line] {_parseSuperq csg $line; eval $c}
		if [string match {*torus \{*} $line]      {_parseTorus csg $line; eval $c}
		if [string match {*sphere \{*} $line] {
			if [string match {*sphere \{ * \}} $line] {; # Rounded Cube
				_parseRndCube $line; incr items
				set currCSGtype "Rounded cube"
			} elseif [string match {*sphere \{*} $line] {; # Sfera normale
				_parseSphere csg $line; eval $c
			}
		}
		if [string match {*box \{*} $line]        {_parseBox csg $line; eval $c}
		if [string match {*plane \{*} $line]      {_parsePlane csg $line; eval $c}
		if [string match {*object \{*} $line] {
			catch {_parseObject $oper $lname $line} res
			# 
			# nel caso *object \{ // name1 -> name ..., _parseObject fa` il gets
			# di una linea con graffa chiusa, quindi occorre aggiornare il braceCnt.
			# 
			if {$res!=""} {incr braceCnt $res}
		}
		if [string match {*text \{*} $line] {
			set name [lindex [lindex [split $line \{] end] end]
			_parseUnsupported Text "\t$name"
		}
		# 
		# per leggere solo le trasformazioni del padre e non dei figli:
		# 
		if {$braceCnt==1} {_parseTransformations $line}
	}		
}

proc _parseDeclare {line} {
	# 
	# Arriva la linea con {\#declare *=*\{*} dal parsing principale.
	# Occorre discriminare ancora cosa viene dichiarato:
	# 
	global oText
	set what [lindex [lindex [split $line \{] 0] end]
	set name [lindex [lindex [split $line \{] 0] 1]
	set ins {$oText insert end "\nDeclare $name ="}
	if {$what=="difference"}   {eval $ins; _parseCSG decl - $line}
	if {$what=="intersection"} {eval $ins; _parseCSG decl * $line}
	if {$what=="union"}        {eval $ins; _parseCSG decl + $line}
	if {$what=="merge"}        {eval $ins; _parseCSG decl ^ $line}
	if {$what=="object"}       {eval $ins; _parseDecObject $line}
	if {$what=="lathe"}        {eval $ins; _parseLathe decl $line}
	if {$what=="mesh"}         {_parseMesh decl $line}
	if {$what=="mesh2"}        {_parseMesh2 decl $line}
	if {$what=="prism"}        {eval $ins; _parsePrism decl $line}
	if {$what=="blob"}         {_parseNotImplemented Blob $name}
	if {$what=="light_source"} {eval $ins; _parseLight dec $line}
	# da verificare, sembra funzioni ma alcune cose vanno verificate
	# - il rename funziona male
	# - MoVib va in errore nella lettura di una poinLight
}

proc _parseDecObject {line} {
	# 
	# Arriva la linea con {\#declare *=*\{*} da inizio riga
	# 
	global inputFile oText mess transfList trashNameList lbDecs currObj
	set name [lindex [lindex [split $line \{] 0] 1]
	gets $inputFile(openId) line
	set primObj [string match {*\{*} $line]
	# 
	# la linea successiva ha una graffa aperta, e` la definizione di una primitiva
	# o di un object referenziato ...
	# 
	if $primObj {
		if [string match {*cylinder \{*} $line] {_parseCylinder dec $line; _refresh}
		if [string match {*cone \{*} $line]     {_parseCone dec $line; _refresh}
		if [string match {*superellipsoid \{*} $line] {_parseSuperq dec $line; _refresh}
		if [string match {*torus \{*} $line]    {_parseTorus dec $line; _refresh}
		if [string match {*sphere \{*} $line]   {_parseSphere dec $line; _refresh}
		if [string match {*box \{*} $line]      {_parseBox dec $line; _refresh}
		if [string match {*plane \{*} $line]    {_parsePlane dec $line; _refresh}
		if [string match {*bicubic_patch \{*} $line] {
			# l'unico caso di bpatch: flat-1Sheet
			_parseBPatch1sheetDec $name $line; _refresh
		}
		if [string match {*height_field \{*} $line] {
			_parseNotImplemented Height_field $name; _refresh
		}
		if [string match {*object \{*} $line]  {_parseObject dec {} $line; _refresh}
	} else {
		# 
		# ... altrimenti e` un declared object name:
		# nella forma \#declare name = object \{* \n name \n Transforms.
		#
		set transfList ""
		set braceCnt 1
		set refName [join $line]
		$oText insert end "\n  $refName"
		while {[gets $inputFile(openId) line]>=0} {
			if [string match {*bounded_by \{*} $line] {
				_parseSkip $line; incr braceCnt -1
			}
			if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
			if [string match {*\{*} $line] {incr braceCnt}
			if [string match {*\}*} $line] {
				incr braceCnt -1
				if {$braceCnt==0} {
					if {$transfList!=""} {
						$oText insert end "\n  \[\n"
						foreach s $transfList {$oText insert end "    $s\n"}
						$oText insert end "  \]"
					}
					$oText insert end "\n"
					_mess grey85 "declared object ($name) -> $refName\n"
					_addObjToList $lbDecs "$name"
					set transfList ""
					return
				}
			}
			_parseTransformations $line
		}
	}
}

proc _parseObject {oper name line} {
	# 
	# Arriva la linea con *object \{* ||
	# Arriva la linea con  object \{* da parsing principale ($oper=="": Toplevel)
	# $name serve:
	# 		> per bicubic_patch che arriva da un declare
	#		> se =="" e' un caso particolare (finora scoperto solo per TransSweep_Raw)
	#			in cui la linea e' solo 'object \{', senza nome commentato, nome
	#			che troviamo nella linea successiva.
	# 
	global oText inputFile transfList trashNameList items lbShapes lbDecs currObj \
		stats skippedList
	                   set sep "  "; set aCapo ""; set sep2 "\t"; set col {}
	if {$oper==""}    {set sep ""; set aCapo "\n"; set sep2 ""; set col cyan}
	if {$oper=="dec"} {set sep ""; set aCapo "\n"; set col cyan}
	set dlist [$lbDecs get 0 end]; # lista degli items dichiarati (e scritti)
	if [string match {object \{} $line] {
		# 
		# caso $line=="object \{" (solo da inizio riga: toplevel TransSweep_Raw)
		# 
		gets $inputFile(openId) line; # nella linea successiva c'e' solo il nome
		set oname [join $line]
		if {[lsearch $trashNameList $oname]!=-1} {
			lappend skippedList "$oname (instance)"
			_mess orange "${sep2}$oname skipped\n"
			return
		}
		if {[lsearch $dlist $oname]==-1} {; # istanza di un oggetto non dichiarato
			_mess orange "${sep2}$oname skipped (RefObiect undeclared)\n"
			lappend skippedList "$oname (RefObject undeclared)"
			return
		}
		if {$oper==""} {
			_mess $col "Toplevel object"
			set olabel "Toplevel refObject"
			_addObjToList $lbShapes $oname
		} else {
			_mess $col "${sep2}Object"
			incr stats(ins)
			set olabel "Instance Object"
			global $currObj
			lappend $currObj $oname
		}
		_mess {} " ($oname)\n"
		$oText insert end "\n${sep}// $olabel $oname \n${sep}$oname"
		incr items
		set transfList ""
		set braceCnt 1
		while {[gets $inputFile(openId) line]>=0} {
			if [string match {*material \{*} $line] {
				_parseSkip $line; incr braceCnt -1
			}
			if [string match {*bounded_by \{*} $line] {
				_parseSkip $line; incr braceCnt -1
			}
			if [string match {*\{*} $line] {incr braceCnt}
			if [string match {*\}*} $line] {
				incr braceCnt -1
				if {$braceCnt==0} {
					if {$transfList!=""} {
						$oText insert end "\n${sep}\[\n"
						foreach s $transfList {$oText insert end "  $s\n"}
						if {$oper==""} {_writeMaterial $oname}
						$oText insert end "${sep}\]"
					} else {
						if {$oper==""} {
							$oText insert end "\n${sep}\[\n"
							_writeMaterial $oname
							$oText insert end "${sep}\]"
						}
					}
					$oText insert end " ${oper}$aCapo"
					set transfList ""
					return
				}
			}
			_parseTransformations $line
		}
	}
	if [string match {* -> *} $line] {
		# 
		# caso *object \{ // name1 -> name ... ed esce
		# 
		set transfList ""
		set braceCnt 1
		set s1 [lindex [split $line \{] end]
		set instanceName [lindex $s1 1]
		set originalName [lindex $s1 end]
		# 
		# l'oggetto e' fra quelli skipped, usciamo:
		# 
		if {[lsearch $trashNameList $originalName]!=-1} {
			_mess orange "${sep2}$instanceName skipped (-> $originalName)\n"
			lappend skippedList "    $instanceName (instance of $originalName)"
			return
		}
		if {[lsearch $dlist $originalName]==-1} {; # istanza di un oggetto non dichiar.
			_mess orange "${sep2}$instanceName skipped\
				(RefObiect $originalName undeclared)\n"
			lappend skippedList "    $instanceName (RefObiect $originalName undeclared)"
			return
		}
		set olabel "Instance Object"
		if {$oper==""} {set olabel "Toplevel refObject"}
		$oText insert end \
			"\n${sep}// $olabel $instanceName \n${sep}$originalName"
		while {[gets $inputFile(openId) line]>=0} {
			if [string match {*bounded_by \{*} $line] {
				_parseSkip $line; incr braceCnt -1
			}
			if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
			if [string match {*\{*} $line] {incr braceCnt}
			if [string match {*\}*} $line] {
				incr braceCnt -1
				if {$braceCnt==0} {
					if {$transfList!=""} {
						$oText insert end "\n${sep}\[\n"
						foreach s $transfList {$oText insert end "${sep}  $s\n"}
						if {$oper==""} {_writeMaterial $instanceName}
						$oText insert end "${sep}\]"
					}
					if {$oper=="dec"} {
						_mess grey85 \
							"declared object ($instanceName) -> $originalName\n"
						_addObjToList $lbDecs "$instanceName"
					} elseif {$oper==""} {
						if {$transfList==""} {
							$oText insert end "\n${sep}\[\n"
							if {$oper==""} {_writeMaterial $instanceName}
							$oText insert end "${sep}\]"
						}
						_mess $col "Toplevel object"
						_mess {} " ($instanceName) -> $originalName\n"
					} else {
						_mess $col "${sep2}Object"
						incr stats(ins)
						_mess {} " ($instanceName) -> $originalName\n"
						global $currObj
						lappend $currObj $instanceName
					}
					if {$oper!="dec"} {$oText insert end " ${oper}"}
					$oText insert end "$aCapo"
					if {$oper==""} {_addObjToList $lbShapes $instanceName}
					set transfList ""
					incr items
					return -1; # aggiorna braceCnt in _parseCSG
				}
			}
			_parseTransformations $line
		}
	}
	if [string match {*object \{*\}*} $line] {
		# 
		# caso *object { name } ... ed esce
		# 
		set oname [lindex [join $line] 1]
		if {[lsearch $trashNameList $oname]!=-1} {
			lappend skippedList "    $oname (instance)"
			_mess orange "${sep2}$oname skipped\n"
			return
		}
		if {[lsearch $dlist $oname]==-1} {; # istanza di un oggetto non dichiar.
			_mess orange "${sep2}$oname skipped (RefObiect undeclared)\n"
			lappend skippedList "    $oname (RefObject undeclared)"
			return
		}
		if {$oper==""} {
			_mess $col "Toplevel object"
			set olabel "Toplevel refObject"
			_addObjToList $lbShapes $oname
		} else {
			_mess $col "${sep2}Object"
			incr stats(ins)
			set olabel "Instance Object"
			global $currObj
			lappend $currObj $oname
		}
		_mess {} " ($oname)\n"
		$oText insert end "\n${sep}// $olabel $oname \n${sep}$oname"
		if {$oper==""} {
			$oText insert end "\n${sep}\[\n"
			_writeMaterial $oname
			$oText insert end "${sep}\]"
		}
		$oText insert end " ${oper}$aCapo"
		incr items
		return
	}
	if [string match {*object \{*} $line] {
		set instName [lindex [lindex [split $line \{] end] end]
		gets $inputFile(openId) line; # linea successiva a *object \{* !!!!!!
		if [string match {*height_field \{*} $line] {
			#
			# height_field
			#
			_parseNotImplemented "Height_field" "${sep2}$instName"
			return
		}
		if [string match {*object \{*} $line] {
			# 
			# se anche nella seconda linea c'e' 'object \{' vuol dire che e` una
			# bicubic_patch piana (solo da inizio riga):
			# 
			$oText insert end "\n// Toplevel bpatch $instName "
			gets $inputFile(openId) line
			_parseBPatch pri $oper $line
			set transfList ""
			set braceCnt 2
			incr stats(pri)
			while {[gets $inputFile(openId) line]>=0} {
				if [string match {*material \{*} $line] {
					_parseSkip $line; incr braceCnt -1
				}
				if [string match {*bounded_by \{*} $line] {
					_parseSkip $line; incr braceCnt -1
				}
				if [string match {*\{*} $line] {incr braceCnt}
				if [string match {*\}*} $line] {
					incr braceCnt -1
					if {$braceCnt==0} {
						if {$transfList!=""} {
							foreach s $transfList {$oText insert end "  $s\n"}
						}
						_writeMaterial $instName
						$oText insert end "\]\n"
						_mess cyan "Toplevel bpatch ($instName)\n"
						_addObjToList $lbShapes $instName
						set transfList ""
						return
					}
				}
				_parseTransformations $line
			}
		}
		if [string match {*bicubic_patch \{*} $line] {
			#
			# bicubic_patch (come union di patches)
			#
			_parseBPatch csg $oper $line
			incr items
			return
		}
		if {[llength $line]==1} {
			# 
			# caso object \{  // name \n name1:  (credo solo da inizio riga!)
			# 
			set oname [join $line]
			if {[lsearch $trashNameList $oname]!=-1} {
				_mess orange "${sep2}$oname skipped\n"
				lappend skippedList "    $oname (instance)"
				return
			}
			if {[lsearch $dlist $oname]==-1} {; # istanza di un oggetto non dichiar.
				_mess orange "${sep2}$oname skipped (RefObject undeclared)\n"
				lappend skippedList "    $oname (RefObject undeclared)"
				return
			}
			$oText insert end \
				"\n// Toplevel refObject $instName  \n$oname"
			set transfList ""
			set braceCnt 1
			while {[gets $inputFile(openId) line]>=0} {
				if [string match {*material \{*} $line] {
					_parseSkip $line; incr braceCnt -1
				}
				if [string match {*bounded_by \{*} $line] {
					_parseSkip $line; incr braceCnt -1
				}
				if [string match {*\{*} $line] {incr braceCnt}
				if [string match {*\}*} $line] {
					incr braceCnt -1
					if {$braceCnt==0} {
						if {$transfList!=""} {
							$oText insert end "\n\[\n"
							foreach s $transfList {$oText insert end "  $s\n"}
							if {$oper==""} {_writeMaterial $instName}
							$oText insert end "\]"
						} else {
							if {$oper==""} {
								$oText insert end "\n\[\n"
								_writeMaterial $instName
								$oText insert end "\]"
							}
						}
						_mess $col "Toplevel object"; _mess {} " ($oname)\n"
						$oText insert end "\n"
						_addObjToList $lbShapes $instName
						set transfList ""
						return
					}
				}
				_parseTransformations $line
			}
		}
	}
}

proc _parseSkip {line} {
	# 
	# Salta uno statement non convertibile.
	# $line deve contenere una graffa aperta. Es.: '*bounded_by {*'
	# Fa il gets da: $line
	# a:             '}'
	# 
	global inputFile
	set braceCnt 1
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*\{*} $line] {
			incr braceCnt
		}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} return
		}
	}
}

