proc _parseCylinder {type line} {
	global inputFile mess oText lbShapes lbDecs transfList currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set closed 0
	set sep ""; set sp2 ""
	set olabel "Primitive Cylinder"
	if {$type=="prm"} {
		_mess cyan "Toplevel cylinder";_mess {} " ($lname)\n"
		set olabel "Toplevel cylinder"
	}
	if {$type=="csg"} {
		_mess {} "\tCylinder ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared cylinder ($lname)\n"}
	gets $inputFile(openId) line; # parametri cilindro e eventuale 'open'
	if {[lindex $line end]!="open"} {set closed 1}
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				if $closed {set sep "  "}
				if $closed {
					$oText insert end \
					"${sep}${sp2}Shape \[ SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
					$oText insert end \
					"{0,0}, {1,0}, {1,1}, {0,1})\n"
				} else {
					$oText insert end \
					"${sep}${sp2}Shape \[ Cylinder ((0,0,0), (0,0,1), 1)\n"
				}
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}
}

proc _parseCone {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set closed 0
	set sep ""; set sp2 ""
	set olabel "Primitive Cone"
	if {$type=="prm"} {
		_mess cyan "Toplevel cone";_mess {} " ($lname)\n"
		set olabel "Toplevel cone"
	}
	if {$type=="csg"} {
		_mess {} "\tCone ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared cone ($lname)\n"}
	gets $inputFile(openId) line; # sempre e solo parametri cono
	set s1 [split $line ,]
	set bRad [join [lindex $s1 3]]; set aRad [join [lindex $s1 end]]
	# 
	# la linea successiva ai parametri cono potrebbe essere 'open':
	# 
	gets $inputFile(openId) line; # possibile riga 'open'
	# 
	# serve ad incominciare il ciclo while senza fare 'gets $inputFile(openId) line'
	# che mi farebbe saltare il contenuto della linea di prima, in caso non abbia
	# la keyword 'open':
	# 
	set hoGiaLaLinea 1
	if {![string match "*open*" $line]} {set closed 1}
	set ln 0
	incr stats(pri)
	while {$ln>=0} {
		if !$hoGiaLaLinea {set ln [gets $inputFile(openId) line]}
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				if $closed {set sep "  "}
				if $closed {
					$oText insert end \
					"${sep}${sp2}Shape \[ SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
					$oText insert end \
					"{0,0}, {$bRad,0}, {$aRad,1}, {0,1})\n"
				} else {
					$oText insert end \
					"${sep}${sp2}Shape \[ Cone ((0,0,0), $bRad, (0,0,1), $aRad)\n"
				}
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
		set hoGiaLaLinea 0
	}
}

proc _parseSuperq {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set sp2 ""
	set olabel "Primitive Superquadric"
	if {$type=="prm"} {
		_mess cyan "Toplevel superquadric";_mess {} " ($lname)\n"
		set olabel "Toplevel superquadric"
	}
	if {$type=="csg"} {
		_mess {} "\tSuperquadric ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared superquadric ($lname)\n"}
	gets $inputFile(openId) line; # sempre e solo parametri superellipsoid
	set s0 [string trimright [string trimleft [join $line] <] >]
	set s1 [split $s0 ,]; set h [join [lindex $s1 1]]; set w [join [lindex $s1 0]]
	set vls "($h, $w)"
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				$oText insert end "${sp2}Shape \[ Superquadric $vls\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseRing {line} {
	global inputFile mess oText lbShapes transfList lbDecs stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	_mess cyan "Toplevel disk";_mess {} " ($lname)\n"
	set braceCnt 1
	set transfList ""
	gets $inputFile(openId) line; # sempre e solo parametri disk
	set innRad [lindex $line end]; # l'inner radius
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n// Toplevel ring $lname \n"
				$oText insert end "Shape \[ Ring ((0,0,0), (0,0,1), 1.0, $innRad)\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				_writeMaterial $lname
				$oText insert end "\]\n"
				 _addObjToList $lbShapes "$lname"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseTorus {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set sp2 ""
	set olabel "Primitive Torus"
	if {$type=="prm"} {
		_mess cyan "Toplevel torus";_mess {} " ($lname)\n"
		set olabel "Toplevel torus"
	}
	if {$type=="csg"} {
		_mess {} "\tTorus ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared torus ($lname)\n"}
	gets $inputFile(openId) line; # parametri torus
	set MRad [string trimright [lindex $line 0] ,]; # major rad
	set mRad [lindex $line 1]; # minor rad
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				$oText insert end \
					"${sp2}Shape \[ Torus ((0, 0, 0), (0, 0, 1), $MRad, $mRad)\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseSphere {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set sp2 ""
	set olabel "Primitive Sphere"
	if {$type=="prm"} {
		_mess cyan "Toplevel sphere";_mess {} " ($lname)\n"
		set olabel "Toplevel sphere"
	}
	if {$type=="csg"} {
		_mess {} "\tSphere ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared sphere ($lname)\n"}
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				$oText insert end "${sp2}Shape \[ Sphere ((0, 0, 0), 1)\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseBox {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set sp2 ""
	set olabel "Primitive Box"
	if {$type=="prm"} {
		_mess cyan "Toplevel box";_mess {} " ($lname)\n"
		set olabel "Toplevel box"
	}
	if {$type=="csg"} {
		_mess {} "\tBox ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared box ($lname)\n"}
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				$oText insert end "${sp2}Shape \[ Box ((-1, -1, -1), (1, 1, 1))\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseLathe {type line} {
	global inputFile mess oText lbShapes transfList lbDecs stats
	gets $inputFile(openId) line1; # sempre linear||quadratic||cubic
	# 
	# l'unico caso certo di corrispondenza POVray-VL e` linear:
	# 
	set olabel "Primitive Lathe"
	if {$type=="prm"}  {set lname [lindex [join [lindex [split $line //] end]] end]}
	if {$type=="decl"} {set lname [lindex [lindex [split $line \{] 0] 1]}
	if {[join $line1]!="linear_spline"} {
		_parseUnsupported "Lathe [join $line1]" $lname
		if {$type=="decl"} {$oText delete "end -1 lines" end}
		return
	} else {
		if {$type=="prm"} {
			_mess cyan "Toplevel lathe";_mess {} " ($lname)\n"
			set olabel "Toplevel lathe"
		}
		if {$type=="decl"} {
			_mess grey85 "declared lathe ($lname)\n"
			_addObjToList $lbDecs "$lname"
		}
	}
	set braceCnt 1
	set transfList ""
	set ptList ""
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n// $olabel $lname \n"
				$oText insert end "Shape \[ SurfaceOfRevolution (STRAIGHT, $nOfPts, \
				(0, 1, 0),\n$ptList2\n  )\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				if {$type=="prm"} {_writeMaterial $lname}
				$oText insert end "\]\n"
				if {$type=="prm"} {_addObjToList $lbShapes "$lname"}
				set transfList ""
				return
			}
		}
		if [string match {*//*control points*} $line] {
			set nOfPts [lindex $line 0]
			for {set n 1} {$n<=$nOfPts} {incr n} {
				gets $inputFile(openId) line
				catch {_vector3 $line} pt
				lappend ptList "   $pt,\n"
			}
			set ptList2 " [string trimright [join $ptList] ,\n]"
		}
		_parseTransformations $line
	}	
}

proc _parsePlane {type line} {
	global inputFile mess oText lbShapes transfList lbDecs currObj stats
	set lname [lindex [join [lindex [split $line //] end]] end]
	set braceCnt 1
	set transfList ""
	set sp2 ""
	set olabel "Primitive Plane"
	if {$type=="prm"} {
		_mess cyan "Toplevel plane";_mess {} " ($lname)\n";	set olabel "Toplevel plane"
	}
	if {$type=="csg"} {
		_mess {} "\tPlane ($lname)\n"; set sp2 "  "
		global $currObj
		lappend $currObj $lname
	}
	if {$type=="dec"} {_mess grey85 "declared plane ($lname)\n"}
	incr stats(pri)
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "\n${sp2}// $olabel $lname \n"
				$oText insert end "${sp2}Shape \[ Disk ((0, 0, 0), (0, 0, 1), 1000)\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "$sp2  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $lname
					_addObjToList $lbShapes "$lname"
				}
				if {$type=="dec"} {_addObjToList $lbDecs "$lname"}
				$oText insert end "${sp2}\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parseRndDisc {line} {
	# 
	# Rounded Disc, $line con 'difference', nella forma:
	# merge \{ // name\n  difference \{\n ...
	# Arriva la linea con il primo 'difference \{' da _parseCSG
	# Tre casi (B, D ed F appunti) (B e D vengono completati in _parseRndDisc1)
	# 
	global inputFile oText
	gets $inputFile(openId) line; # primo cilindro
	set sc1 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
	set tc1 {}
	if [string match {*translate*} $line] {
		set tc1 [lindex [split [lindex [lindex $line end] end] *] 0]
		set tc1 " Translate (0.0, 0.0, $tc1)"
	}
	$oText insert end "\n  Solid \[\n    Shape \["
	$oText insert end "SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
	$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc1)$tc1\]-\n"
	$oText insert end "    Shape \["
	
	gets $inputFile(openId) line; # secondo cilindro
	set sc2 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
	set tc2 [lindex [split [lindex [lindex $line end] end] *] 0]
	$oText insert end "SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
	$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc2)"
	$oText insert end " Translate (0.0, 0.0, $tc2)\]\n  \]"
	
	gets $inputFile(openId) line
	gets $inputFile(openId) line
	# ritorna l'ultima linea catturata da _parseRndDisc1:
	if [string match {*difference \{*} $line] {
		$oText insert end "+\n  Solid \[\n    Shape \["
		return [_parseRndDisc1]
	} else {; # caso F
		$oText insert end "\n"
		return $line
	}
}

proc _parseRndDisc1 {} {
	# 
	# Casi B e D appunti (1b pag. 32)
	# 
	global inputFile oText
	gets $inputFile(openId) line; # terzo cilindro
	set sc3 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
	set tc3 [lindex [split [lindex [lindex $line end] end] *] 0]
	$oText insert end "SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
	$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc3)"
	$oText insert end " Translate (0.0, 0.0, $tc3)\]-\n"
	$oText insert end "    Shape \["

	gets $inputFile(openId) line; # quarto cilindro
	set sc4 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
	set tc4 [lindex [split [lindex [lindex $line end] end] *] 0]
	$oText insert end "SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
	$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc4)"
	$oText insert end " Translate (0.0, 0.0, $tc4)\]\n  \]+\n"
	
	gets $inputFile(openId) line
	gets $inputFile(openId) line; # primo torus
	set Mr1 [string trimright [lindex [lindex $line end] 0] ,]
	set mr1 [lindex [lindex $line end] 1]
	set tt1 [lindex [split [lindex [lindex $line end] 5] *] 0]
	$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr1, $mr1)"	
	$oText insert end " Translate (0.0, 0.0, $tt1)\]+\n"
	
	gets $inputFile(openId) line; # secondo torus
	set Mr2 [string trimright [lindex [lindex $line end] 0] ,]
	set mr2 [lindex [lindex $line end] 1]
	set tt2 [lindex [split [lindex [lindex $line end] 5] *] 0]
	$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr2, $mr2)"
	$oText insert end " Translate (0.0, 0.0, $tt2)\]"
	
	gets $inputFile(openId) line; # terzo e quarto torus, se ci sono:
	if [string match {*torus \{*} $line] {;# caso B
		$oText insert end "+\n"
		set Mr3 [string trimright [lindex [lindex $line end] 0] ,]
		set mr3 [lindex [lindex $line end] 1]
		set tt3 [lindex [split [lindex [lindex $line end] 5] *] 0]
		$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr3, $mr3)"
		$oText insert end " Translate (0.0, 0.0, $tt3)\]+\n"
		
		gets $inputFile(openId) line; # quarto torus
		set Mr4 [string trimright [lindex [lindex $line end] 0] ,]
		set mr4 [lindex [lindex $line end] 1]
		set tt4 [lindex [split [lindex [lindex $line end] 5] *] 0]
		$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr4, $mr4)"
		$oText insert end " Translate (0.0, 0.0, $tt4)\]\n"
		return ""
	} else {;# caso D; in $line possono esserci trasformazioni, bounde_by, material
		$oText insert end "\n"
		return $line
	}
}

proc _parseRndDisc2 {line} {
	# 
	# Casi A, C ed E appunti (1b pag. 32/33)
	# 
	global inputFile oText
	# primo cilindro
	set sc1 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
	$oText insert end "\n  Shape \[SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
	$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc1)\]"
	# secondo cilindro, torus o nulla, transf, bound, ecc:
	gets $inputFile(openId) line
	if [string match {*cylinder \{*} $line] {;# caso C
		$oText insert end "^\n"
		# secondo cilindro
		set sc2 [string trimleft [string trimright [lrange [lindex $line end] 3 5] >] <]
		set tc2 [lindex [split [lindex [lindex $line end] end] *] 0]
		$oText insert end "  Shape \[SurfaceOfRevolution (STRAIGHT, 4, (0,0,1), "
		$oText insert end "{0,0}, {1,0}, {1,1}, {0,1}) Scale ($sc2)"
		$oText insert end " Translate (0.0, 0.0, $tc2)\]^\n"
		gets $inputFile(openId) line; # primo torus
		set Mr1 [string trimright [lindex [lindex $line end] 0] ,]
		set mr1 [lindex [lindex $line end] 1]
		set tt1 [lindex [split [lindex [lindex $line end] 5] *] 0]
		$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr1, $mr1)"	
		$oText insert end " Translate (0.0, 0.0, $tt1)\]^\n"
		gets $inputFile(openId) line; # secondo torus
		set Mr2 [string trimright [lindex [lindex $line end] 0] ,]
		set mr2 [lindex [lindex $line end] 1]
		set tt2 [lindex [split [lindex [lindex $line end] 5] *] 0]
		$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr2, $mr2)"
		$oText insert end " Translate (0.0, 0.0, $tt2)\]\n"
	} elseif [string match {*torus \{*} $line] {; # caso A
		$oText insert end "^\n"
		set Mr1 [string trimright [lindex [lindex $line end] 0] ,]
		set mr1 [lindex [lindex $line end] 1]
		set tt1 [lindex [split [lindex [lindex $line end] 5] *] 0]
		$oText insert end "  Shape \[Torus ((0, 0, 0), (0, 0, 1), $Mr1, $mr1)"	
		$oText insert end " Translate (0.0, 0.0, $tt1)\]\n"
	} else {; # caso E
		$oText insert end "\n"
		return $line
	}
}

proc _parseRndCube {line} {
	# 
	# Rounded Cube plugin, nella forma:
	# merge \{  // name\n  sphere { ... }
	# o:
	# #declare name = merge \{\n  sphere { ... }
	# Arriva la linea con la prima 'sphere' da _parseCSG
	global inputFile oText
	set pos [string trimleft [join [lindex [split [lindex $line end] >] 0]] <]
	set rad [string trimleft [join [lindex [split [lindex $line end] >] end]] ", "]
	$oText insert end "\n  Shape \[Sphere (($pos), $rad)\]^"
	for {set n 1} {$n<=7} {incr n} {
		gets $inputFile(openId) line
		set pos [string trimleft [join [lindex [split [lindex $line end] >] 0]] <]
		set rad [string trimleft [join [lindex [split [lindex $line end] >] end]] ", "]
		$oText insert end "\n  Shape \[Sphere (($pos), $rad)\]^"
	}
	for {set n 1} {$n<=12} {incr n} {
		gets $inputFile(openId) line
		set pos1 [string trimleft [join [lindex [split [lindex $line end] >] 0]] <]
		set pos2 [string trimleft [join [lindex [split [lindex $line end] >] 1]] ", <"]
		set rad [string trimleft [join [lindex [split [lindex $line end] >] end]] ", "]
		$oText insert end "\n  Shape \[Cylinder (($pos1), ($pos2), $rad)\]^"
	}
	for {set n 1} {$n<=3} {incr n} {
		gets $inputFile(openId) line
		set pos1 [string trimleft [join [lindex [split [lindex $line end] >] 0]] <]
		set pos2 [string trimleft [join [lindex [split [lindex $line end] >] 1]] <]
		$oText insert end "\n  Shape \[Box (($pos1), ($pos2))\]^"
	}
}

proc _parsePrism_old {type line} {
	# 
	# Primitiva da parsing principale o declared da _parseDeclare
	# Trasformazione in Polygons.
	# 
	global inputFile oText stats lbShapes lbDecs transfList
	if {$type=="prm"}  {set name [lindex [lindex [split $line \{] end] end]}
	if {$type=="decl"} {set name [lindex [lindex [split $line \{] 0] 1]}
	gets $inputFile(openId) line
	if [string match {*conic_sweep*} $line] {
		if {$type=="decl"} {$oText delete "end -1 lines" end}
		_parseUnsupported {Prism (conic_sweep)} $name
		return
	}
	gets $inputFile(openId) line
	if ![string match {*linear_spline*} $line] {
		if {$type=="decl"} {$oText delete "end -1 lines" end}
		_parseUnsupported "Prism ([join $line])" $name
		return
	}
	set braceCnt 1
	set transfList ""
	if {$type=="prm"} {
		_mess cyan "Toplevel ";_mess {} " ($name)\n"
		$oText insert end "\n// Toplevel Prism $name \n"
	}
	if {$type=="decl"} {
		_mess grey85 "declared prism ($name)\n"
		$oText insert end "\n"
	}
	incr stats(pri)
	$oText insert end "Solid \[\n"
	gets $inputFile(openId) line
	set h1 [join [lindex [split $line ,] 0]]
	set h2 [join [lindex [split $line ,] 1]]
	gets $inputFile(openId) line
	set nOfPts [join [lindex $line 0]]
	for {set n 1} {$n<=$nOfPts} {incr n} {
		gets $inputFile(openId) line
		set l [split [string trimleft [string trimright [join $line] ">,"] <] ,]
		set x [join [lindex $l 0]]; set z [join [lindex $l 1]]
		lappend plist "$x $z"
	}
	for {set n 0} {$n<=[expr [llength $plist] -2]} {incr n} {
		set p1 [lindex $plist $n]; set p2 [lindex $plist [expr $n +1]]
		set x1 [lindex $p1 0]; set x2 [lindex $p2 0]
		set z1 [lindex $p1 1]; set z2 [lindex $p2 1]
		$oText insert end "  Shape \[Polygon (4,\
		($x1,$h1,$z1), ($x2,$h1,$z2), ($x2,$h2,$z2), ($x1,$h2,$z1))\]+\n"
	}
	# 
	# Poligoni di chiusura sopra-sotto:
	# 
	foreach pl {h1 h2} {
		$oText insert end "  Shape \[Polygon ($nOfPts,\n    "
		set cnt -1
		foreach p $plist {
			incr cnt
			if {$cnt==4} {$oText insert end "\n    "; set cnt 0}
			$oText insert end "([lindex $p 0],[set $pl],[lindex $p 1]), "
		}
		$oText delete "end -1 lines lineend -2c" end
		$oText insert end ")\]+\n"
	}
	$oText delete "end -1 lines lineend -2c" end
	$oText insert end "\n"
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $name
					_addObjToList $lbShapes "$name"
				}
				if {$type=="decl"} {_addObjToList $lbDecs "$name"}
				$oText insert end "\]\n"
				set transfList ""
				return
			}
		}
		_parseTransformations $line
	}	
}

proc _parsePrism {type line} {
	# 
	# Primitiva da parsing principale o declared da _parseDeclare
	# 
	global inputFile oText stats lbShapes lbDecs transfList
	if {$type=="prm"}  {set name [lindex [lindex [split $line \{] end] end]}
	if {$type=="decl"} {set name [lindex [lindex [split $line \{] 0] 1]}
	gets $inputFile(openId) line
	if [string match {*conic_sweep*} $line] {
		if {$type=="decl"} {$oText delete "end -1 lines" end}
		_parseUnsupported {Prism (conic_sweep)} $name
		return
	}
	gets $inputFile(openId) line
	if ![string match {*linear_spline*} $line] {
		if {$type=="decl"} {$oText delete "end -1 lines" end}
		_parseUnsupported "Prism ([join $line])" $name
		return
	}
	set olabel "Primitive Prism"
	set braceCnt 1
	set transfList ""
	if {$type=="prm"} {
		_mess cyan "Toplevel ";_mess {} " ($name)\n"
		$oText insert end "\n// Toplevel Prism $name \n"
	}
	if {$type=="decl"} {
		_mess grey85 "declared prism ($name)\n"
		$oText insert end "\n"
	}
	set ptList ""; set plist ""
	incr stats(pri)
	$oText insert end "Solid \[\n"
	gets $inputFile(openId) line
	set h1 [join [lindex [split $line ,] 0]]
	set h2 [join [lindex [split $line ,] 1]]
	set h [expr abs($h1-$h2)]
	while {[gets $inputFile(openId) line]>=0} {
		if [string match {*bounded_by \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*material \{*} $line] {_parseSkip $line; incr braceCnt -1}
		if [string match {*\{*} $line] {incr braceCnt}
		if [string match {*\}*} $line] {
			incr braceCnt -1
			if {$braceCnt==0} {
				$oText insert end "  Shape \[ExtrudedSurface (STRAIGHT, $nOfPts, \
				(0, $h, 0),\n$ptList2)\n"
				$oText insert end "    Rotate (180, 0, 0) Translate (0, $h2, 0)\]+\n"
				# 
				# Poligoni di chiusura (errori in CSG)
				# 
				foreach pl {h1 h2} {
					$oText insert end "  Shape \[Polygon ($nOfPts,\n    "
					set cnt -1
					foreach p $plist {
						incr cnt
						if {$cnt==4} {$oText insert end "\n    "; set cnt 0}
						$oText insert end "([lindex $p 0],[set $pl],[lindex $p 1]), "
					}
					$oText delete "end -1 lines lineend -2c" end
					$oText insert end ")\]+\n"
				}
				$oText delete "end -1 lines lineend -2c" end
				$oText insert end "\n"
				$oText insert end "  Rotate (-90, 0, 0)\n"
				if {$transfList!=""} {
					foreach s $transfList {$oText insert end "  $s\n"}
				}
				if {$type=="prm"} {
					_writeMaterial $name
					_addObjToList $lbShapes "$name"
				}
				if {$type=="decl"} {_addObjToList $lbDecs "$name"}
				$oText insert end "\]\n"
				set transfList ""
				return
			}
		}
		if [string match {*//*control points*} $line] {
			set nOfPts [lindex $line 0]
			for {set n 1} {$n<=$nOfPts} {incr n} {
				gets $inputFile(openId) line
				catch {_vector3 $line} pt
				lappend ptList "   $pt,\n"
				set l [split [string trimleft \
					[string trimright [join $line] ">,"] <] ,]
				set x [join [lindex $l 0]]; set z [join [lindex $l 1]]
				lappend plist "$x $z"
			}
			gets $inputFile(openId) line; # la rotazione fissa di -90 in x:
			set line {}; # altrimenti la linea 'rot. fissa -90' la legge il while
			set ptList2 " [string trimright [join $ptList] ,\n]"
		}
		_parseTransformations $line
	}	
}

proc _parseUnsupported {type name} {
	global trashNameList stats skippedList
	set trimmed [string trim $name]
	lappend trashNameList $trimmed
	lappend skippedList "$name ($type)"
	_mess orange "$name -> $type not supported by VL. Skipped\n"
	incr stats(skp)
	_refresh
}

proc _parseNotImplemented {type name} {
	global trashNameList stats skippedList
	set trimmed [string trim $name]
	lappend trashNameList $trimmed
	lappend skippedList "$name ($type)"
	_mess orange "$name -> $type not implemented. Skipped\n"
	incr stats(skp)
	_refresh
}

