proc _render {} {
	global render tmpDir oText thumb outputFile vlrDir errorInfo
	set fname $tmpDir/MoVibTmpScene
	set f [open $fname.vib w]
	puts $f [$oText get 1.0 end]
	close $f
	set size {}
	set mthd {}
	set stats {}
	set sw [format %.0f [expr $render(sizew) * $render(sizem)]]
	set sh [format %.0f [expr $render(sizeh) * $render(sizem)]]
	if $render(sizeOn) {set size "-r $sw $sh"}
	if $render(stats) {set stats "-d"}
	switch $render(method) {
		1 {set mthd {}}
		2 {set mthd {-h 1}}
		3 {set mthd {-h 2}}
		4 {set mthd {-h 3}}
		5 {set mthd {-O 1}}
		6 {set mthd {-O 2}}
		7 {set mthd {-O 3}}
	}
	# 
	# !--> vlight non deve terminare con &
	# !--> [auto_execok start] serve in NT, altrimenti non apre la DOS shell di vlight
	# 
	catch {eval exec [auto_execok start] vlight $fname -L -f $size $mthd $stats}
	if {$render(thumb)==1} {
		if {$render(method)>4} {
			$thumb config -image {}
			$thumb config -bd 0
		} else {
			_renderMakeThumb
		}
	}
	_searchVlError
}

proc _searchVlError {} {
	global tmpDir oText gui commText
	if ![file exists $tmpDir/MoVibTmpScene.log] return
	set l [open $tmpDir/MoVibTmpScene.log r]
	set logTxt [read $l]
	close $l
	set errSrc1 [lsearch $logTxt ERROR]
	set errSrc2 [lsearch $logTxt error]
	set errSrc3 [lsearch $logTxt Error]
	if {$errSrc1!=-1||$errSrc2!=-1||$errSrc3!=-1} {
		_renderViewLog
		_state $commText normal
		set errSrc4 [$commText search "near or on line " 1.0]
		_state $commText disabled
		if {$errSrc4!=-1} {
			set i [$commText get "$errSrc4 +16 c" "$errSrc4 +16 c wordend"]
			$oText tag remove sel 1.0 end
			$oText see $i.0
			$oText mark set insert $i.0
			$oText tag add sel $i.0 "$i.0 +1l"
			set gui(vibFrame) 1
			_vibFrame
			focus $oText
		}
	}
}

proc _renderMakeThumb {} {
	global render tmpDir cam thumb
	set tgaName [file nativename $tmpDir/MoVibTmpScene.tga]
	set pngName [file nativename $tmpDir/MoVibThumb.png]
	if ![file exists $tgaName] return
	set r1 [expr $render(sizew) / 160.00000]
	set r2 [expr $render(sizeh) / 160.00000]
	set r $r1
	if {$r2>$r1} {set r $r2}
	set w [expr $render(sizew) / $r]
	set h [expr $render(sizeh) / $r]
	# 
	# Se va in errore interno di nconvert non me ne accorgo:
	# (bisognerebbe fare ricerca di stringhe 'Error' nel $ncErr
	# e lanciare una tk_messageBox). Stesso discorso in _showRenderImage
	# 
	set nccomm {exec nconvert -quiet -out png -o $pngName -resize $w $h $tgaName}
	if [catch $nccomm ncErr] return; # anche se il file tga e' incompleto
	if [file exists $pngName] {
		$thumb config -image [image create photo -file $pngName]
		$thumb config -bd 2
		if [winfo exists .ri] _showRenderImage
	}
}

proc _renderViewLog {} {
	global tmpDir
	if ![file exists $tmpDir/MoVibTmpScene.log] return
	set l [open $tmpDir/MoVibTmpScene.log r]
	set t [read $l]
	if {$t!=""} {
		_messageText . "VirtuaLight log" {} {}
		_messageTextInsert $t
	}
	close $l
}

proc _showRenderImage {} {
	global tmpDir
	set imName1 $tmpDir/MoVibTmpScene.tga
	set imName2 $tmpDir/MoVibTmpScene.png
	if ![file exists $imName1] {tk_messageBox -message "Image missing"; return}
	set nccomm {exec nconvert -quiet -out png -o $imName2 $imName1}
	if [catch $nccomm ncErr] return
	set im [image create photo -file $imName2]
	if [winfo exists .ri] {.ri.lb config -image $im; return}
	toplevel .ri
	wm geometry .ri +[winfo pointerx .]+[winfo pointery .]
	wm transient .ri .
	wm title .ri "Last rendering"
	wm resizable .ri 0 0
	bind .ri <Escape> {destroy .ri}
	label .ri.lb -image $im
	pack .ri.lb -fill both -expand 1
}
