proc _setupWin {type} {
	global tmpVlrDir tmpTmpDir tmpArcDir tmpInpDir
	toplevel .su
	wm transient .su .
	wm title .su "MoVib system directories"
	wm resizable .su 1 0
	#
	# $type==1 - le variabili tmpVlrDir tmpTmpDir tmpInpDir tmpArcDir sono settate
	# temporaneamente al primo avvio di MoVib.
	# $type==0 - leggiamo il file MoVib_setup.tcl gia' creato dall'utente.
	# 
	if !$type {
		set sf [open MoVib_setup.tcl r]
		while {[gets $sf line]>=0} {
			if {[lindex $line 1]=="vlrDir"}           {set tmpVlrDir [lindex $line 2]}
			if {[lindex $line 1]=="tmpDir"}           {set tmpTmpDir [lindex $line 2]}
			if {[lindex $line 1]=="inputFile(dir)"}   {set tmpInpDir [lindex $line 2]}
			if {[lindex $line 1]=="archiveFile(dir)"} {set tmpArcDir [lindex $line 2]}
		}
		close $sf
	}
	label .su.l1 -text "Virtualight Root Directory:" -fg white
	pack .su.l1 -anchor w
	_insertSetDir .su.vlroot 50 tmpVlrDir _setVlRootDir
	_bindEnterLeave .su.vlroot "VL root directory"
	label .su.l2 -text "Default input directory (POV files):" -fg white
	pack .su.l2 -anchor w
	_insertSetDir .su.idir 5 tmpInpDir _setInputDir
	_bindEnterLeave .su.idir "Default input directory"
	label .su.l3 -text "Default ReadArchive directory:" -fg white
	pack .su.l3 -anchor w
	_insertSetDir .su.adir 5 tmpArcDir _setArchDir
	_bindEnterLeave .su.adir "Default ReadArchive directory"
	label .su.l4 -text "Temporary directory:" -fg white
	pack .su.l4 -anchor w
	_insertSetDir .su.tmpdir 5 tmpTmpDir _setTmpDir
	_bindEnterLeave .su.tmpdir "Temporary directory"
	frame .su.bt -relief ridge -bd 2
	button .su.bt.ok -text "Save" -width 10 -command "_saveSetup $type"
	button .su.bt.cn -text " Exit MoVib setup " -command exit
	button .su.bt.ds -text "Dismiss" -width 10 -command "grab .; destroy .su"
	pack .su.bt -fill x -padx 2 -pady 2
	if !$type {pack .su.bt.ds -side right}
	pack .su.bt.ok -side right
	if $type {pack .su.bt.cn -side right}
	if $type {
		tkwait visibility .su
		set screenW [winfo vrootwidth .]
		set screenH [winfo vrootheight .]
		set MoVibW [winfo width .su]
		set MoVibH [winfo height .su]
		set MoVibX [expr ($screenW/2)-($MoVibW/2)]
		set MoVibY [expr ($screenH/2)-($MoVibH/2)]
		wm geometry .su +$MoVibX+$MoVibY
	} else {
		wm geometry .su +[winfo pointerx .]+[winfo pointery .]
	}
	grab .su
	focus .su
}

proc _settingsWin {} {
	global uvSteps gui iniMatOn iniMat tmpSettings
	toplevel .st
	wm geometry .st +[winfo pointerx .]+[winfo pointery .]
	wm transient .st .
	wm title .st "Settings"
	wm resizable .st 1 0
	set tmpSettings(uvSteps) $uvSteps
	set tmpSettings(tcounter) $gui(tcounter)
	set tmpSettings(iniMatOn) $iniMatOn
	set tmpSettings(iniMat) $iniMat
	set tmpSettings(vibWin) $gui(vibFrame)
	set tmpSettings(logWin) $gui(messFrame)
	set tmpSettings(renWin) $gui(renderFrame)
	set tmpSettings(sbars) $gui(scrollbars)
	set tmpSettings(listSkip) $gui(listSkip)
	_insertLbMb .st.uvs 16 4 "Bpatch UV steps" "2 3 4 5 6 7 8 9 10" {} \
		tmpSettings(uvSteps)
	_insertSeparator .st.s2
	checkbutton .st.ct -text "Triangles/Bpatches counter" -var tmpSettings(tcounter)
	checkbutton .st.vw -text "VIB window" -var tmpSettings(vibWin)
	checkbutton .st.lw -text "Log window" -var tmpSettings(logWin)
	checkbutton .st.rw -text "Render window" -var tmpSettings(renWin)
	checkbutton .st.sb -text "Scrollbars" -var tmpSettings(sbars)
	checkbutton .st.sk -text "Skipped window" -var tmpSettings(listSkip)
	pack .st.ct .st.vw .st.lw .st.rw .st.sb .st.sk -anchor w
	_insertCbLbEn .st.im 10 "Default material" tmpSettings(iniMatOn) \
		tmpSettings(iniMat) n
	_insertSeparator .st.s4
	_insertLbBt .st.af 24 8 "Default ReadArchive files" "List ..." \
		{_readArchiveMngt ini .st}
	_insertSeparator .st.s5
	_insertApplyOtherDismiss .st.bt .st . Save _applySettings _saveSettings
	.st.bt.cn config -command "grab .; destroy .st"; # bottone Dismiss
	grab .st
	focus .st
}

proc _applySettings {} {
	global gui iniMat iniMatOn uvSteps tmpSettings
	set uvSteps $tmpSettings(uvSteps)
	set iniMatOn $tmpSettings(iniMatOn)
	set iniMat $tmpSettings(iniMat)
	set gui(tcounter) $tmpSettings(tcounter)
	set gui(vibFrame) $tmpSettings(vibWin)
	set gui(messFrame) $tmpSettings(logWin)
	set gui(renderFrame) $tmpSettings(renWin)
	set gui(scrollbars) $tmpSettings(sbars)
	set gui(listSkip) $tmpSettings(listSkip)
	_scrollbars; _vibFrame; _messFrame; _renderFrame
	grab .; destroy .st
}

proc _saveSettings {} {
	global archiveFile gui iniMat iniMatOn uvSteps
	_applySettings
	set f [open MoVib_config.tcl w]
	puts $f "#\n# Settings written by MoVib File>Settings command\n#"
	set vlist {
		archiveFile(inilist) iniMat iniMatOn uvSteps gui(tcounter) gui(vibFrame) \
		gui(messFrame) gui(renderFrame) gui(scrollbars) gui(listSkip)
	}
	foreach v $vlist {puts $f "set $v \"[set $v]\""}
	puts $f {}
	close $f
}

proc _saveSetup {type} {
	global tmpVlrDir tmpTmpDir tmpInpDir tmpArcDir iniMat iniMatOn uvSteps \
		archiveFile gui inputFile outputFile tmpDir vlrDir
	set f [open MoVib_setup.tcl w]
	puts $f "#\n# Settings written by MoVib File>Setup command\n#"
	puts $f "set vlrDir \"$tmpVlrDir\""
	puts $f "set tmpDir \"$tmpTmpDir\""
	puts $f "set inputFile(dir) \"$tmpInpDir\""
	puts $f "set archiveFile(dir) \"$tmpArcDir\""
	puts $f {}
	close $f
	if {$type==1} {source MoVib_setup.tcl}
	wm deiconify .
	grab .; destroy .su
}

proc _setVlRootDir {} {
	global tmpVlrDir
	set dname [tk_chooseDirectory -initialdir $tmpVlrDir \
		-title "VirtuaLight root directory" -mustexist 1 -parent .su
		]
	if {$dname==""} return
	set tmpVlrDir $dname
}

proc _setTmpDir {} {
	global tmpTmpDir
	set dname [tk_chooseDirectory -initialdir $tmpTmpDir \
		-title "Temporary directory" -mustexist 1 -parent .su
		]
	if {$dname==""} return
	set tmpTmpDir $dname
}

proc _setInputDir {} {
	global tmpInpDir
	set dname [tk_chooseDirectory -initialdir $tmpInpDir \
		-title "Default input directory" -mustexist 1 -parent .su
		]
	if {$dname==""} return
	set tmpInpDir $dname
}

proc _setArchDir {} {
	global tmpArcDir
	set dname [tk_chooseDirectory -initialdir $tmpArcDir \
		-title "Default ReadArchive directory" -mustexist 1 -parent .su
		]
	if {$dname==""} return
	set tmpArcDir $dname
}

