proc _buildTree {n} {
	# 
	# 0 == load di un file .vib
	# 1 == conversione originale da .pov
	# 2 == expand all dal tree
	# 
	global lbShapes objList fathersList allObjList
	if {$n==1} {
		_mess {} "---------------------------------------------------------\n"
		_mess {} "Building hierarchy tree ... "; _refresh
	}
	set tlList [$lbShapes get 0 end]
	if {$tlList==""} {_mess {} "No toplevel items.\n\n"; return}
	foreach t $tlList {_parseTree $n $t /}
	if {$n==1} {
		_mess {} "[llength $allObjList] objects.\n"
		_mess {} "Done.\n"
		_refresh
		_createObjMatArray
	}
}

proc _parseTree {n i path} {
	# 
	# n:
	# 0 == load di un file .vib
	# 1 == conversione originale da .pov
	# 2 == expand all dal tree
	# 
	global tree objList Tree $i fathersList mess allObjList
	# 
	# fathersList e' la lista degli items padri (colorati in cyan) in forma di 
	# path completo (/n1/n2/n3 ...)
	# allObjList e' la lista completa di tutti gli elementi del tree (path completo)
	# 
	if [info exists $i] {
		set father 0
		Tree:newitem $tree ${path}$i -tags "cyan $i"
		if {$n!=2} {lappend allObjList ${path}$i}
		if {$n!=2} {lappend fathersList ${path}$i}
		set Tree($tree:${path}$i:open) 1; # open di tutti componenti
		set comps [set $i]
		foreach c $comps {
			set idx [lsearch $objList $c]
			if {$idx!=-1} {
				_parseTree $n $c ${path}$i/
				set father 1
			} else {
				Tree:newitem $tree ${path}$i/$c -tags "white $c"
				if {$n!=2} {lappend allObjList ${path}$i/$c}
				set father 1
			}
		}
		# 
		# caso di oggetto dichiarato ma senza figli:
		# 
		if {$father==0} {
			Tree:delitem $tree ${path}$i
			Tree:newitem $tree ${path}$i -tags "white $i"
			# if {$n!=2} {lappend allObjList ${path}$i}
			if {$n!=2} {set fathersList [lreplace $fathersList end end]}
		}
	}
}

proc _collapseAll {} {
	global tree fathersList done
	if {$done(parsing)==0} return
	_cursor watch
	foreach i $fathersList {Tree:close $tree $i}
	_cursor {}
}

proc _expandAll {} {
	global Tree tree done
	if {$done(parsing)==0} return
	_cursor watch
	foreach c $Tree($tree:/:children) {catch {Tree:delitem $tree /$c}}
	_buildTree 2
	_cursor {}
}

proc _popupTree {X Y x y} {
	global tree lbMats fathersList TreeSelection
	.tree delete 0 end
	set name [Tree:labelat $tree $x $y]
	set st normal; set mat {}; set st2 normal
	set matSele [$lbMats curselection]
	if {$matSele==""} {set st disabled}
	if {$matSele!=""} {set mat '[$lbMats get $matSele]'}
	if {$name!=""} {
		set cm [_readCurrMaterial [file tail $name]]; set cm2 '${cm}'
		if {$cm==""} {set cm "no material"; set st2 disabled; set cm2 {}}
		.tree add command -label "[file tail $name] \[$cm\]:" -state disabled
		.tree add separator
		.tree add command -label "Assign material $mat" \
			-state $st -comm "_setMatToObj add single $name" -foreground blue
		.tree add command -label "Remove material $cm2" -state $st2 -comm \
			"_setMatToObj del single $name"
		if {[lsearch $fathersList $name]!=-1} {
			.tree add separator
			.tree add command -label "Collapse" -command "_expandBranch $name close"
			.tree add command -label "Expand" -command "_expandBranch $name open"
		}
	} else {
		.tree add command -label "[llength $TreeSelection] item(s) selected" \
			-state disabled
		.tree add separator
		.tree add command -label "Collapse all tree" -command "_collapseAll"
 		.tree add command -label "Expand all tree" -command "_expandAll"
		.tree add separator
		.tree add command -label "Select objects:" -state disabled
		.tree add command -label "  none" -command {_selectAll 0}
		.tree add command -label "  all" -command {_selectAll 1}
		.tree add command -label "  toplevels only" -command _selectTops
		.tree add cascade -label "  only with material" \
			-menu .tree.m1
		.tree add command -label "  by pattern ..." -command _selectPatternWin
		.tree add separator
		.tree add command -label "Assign material $mat" \
			-state $st -command "_setMatToSele add" -foreground blue
		.tree add command -label "Remove material" -state $st2 \
			-comm "_setMatToSele del"
	}
	tk_popup .tree $X $Y
}

proc _expandBranch {branch op} {
	global tree fathersList
	_cursor watch
	foreach i $fathersList {
		if [string match "$branch/*" $i] {Tree:$op $tree $i}
	}
	Tree:$op $tree $branch
	_cursor ""
}

proc _setSelection {col x y} {
	global tree
	# 
	# Tree:labelat mi restituisce il path completo dell'item
	# 
	set lbl [Tree:labelat $tree $x $y]
	Tree:setselection $lbl
	if {$col=="cyan"} {_selectGroup $lbl}
}

proc Tree:setselection {v} {
	# $v e' il path completo dell'item
	global tree Tree TreeSelection
	if {$v==""} return
	set vInd [lsearch $TreeSelection $v]
	if {$vInd!=-1} {; # l'item e' gia' selezionato, quindi lo deselezioniamo:
		$tree delete $v
		set TreeSelection [lreplace $TreeSelection $vInd $vInd]
		_selectedCount
		return
	}; # altrimenti lo aggiungiamo a TreeSelection:
	lappend TreeSelection $v
	_selectedCount
	Tree:drawselection $v
}

proc _setGroup {v toSelect} {
	# $v e' il path completo dell'item
	global tree Tree TreeSelection
	set vInd [lsearch $TreeSelection $v]
	if {$vInd!=-1&&$toSelect==0} {; # l'item e' gia' selezionato ma va deselezionato:
		$tree delete $v
		set TreeSelection [lreplace $TreeSelection $vInd $vInd]
		_selectedCount
	}
	if {$vInd==-1&&$toSelect==1} {; # l'item non e' selezionato e va selezionato:
		lappend TreeSelection $v
		_selectedCount
		Tree:drawselection $v
	}
}

proc Tree:drawselection {v} {
	# $v e' il path completo dell'item
	global tree Tree TreeSelection
	if {[string length $v]==0} return
	if {![info exists Tree($tree:$v:tag)]} return
	set bbox [$tree bbox $Tree($tree:$v:tag)]
	if {[llength $bbox]==4} {
		$tree create rectangle $bbox -outline yellow -tags "$v seleBox"
		$tree lower seleBox x
	}
}

proc _drawSelection {} {
	# 
	# arriva da Tree:build (open || close branch)
	# 
	global TreeSelection
	foreach s $TreeSelection {Tree:drawselection $s}
}

proc _selectGroup {father} {
	# 
	# nel caso di selezione di un father nel tree
	# 
	global tree Tree fathersList TreeSelection
	if {$father==""} return
	set toSelect 0
	# l'item e' stato appena selezionato:
	if {[lsearch $TreeSelection $father]!=-1} {set toSelect 1}
	set childs $Tree($tree:$father:children)
	foreach i $childs {
		_setGroup $father/$i $toSelect
		if {[lsearch $fathersList $father/$i]!=-1} {
			_selectGroup $father/$i
		}
	}
}

proc _selectedCount {} {
	global TreeSelection
	.f3.lb config -text "[llength $TreeSelection] item(s) selected"
}

proc _selectAll {n} {
	global tree TreeSelection allObjList
	set TreeSelection {}
	$tree delete seleBox
	if {$n==1} {; # select all
		set TreeSelection $allObjList
		foreach i $allObjList {Tree:drawselection $i}
	}
	_selectedCount
}

proc _selectTops {} {
	global lbShapes tree TreeSelection allObjList
	set olist [$lbShapes get 0 end]
	if {$olist==""} return
	set TreeSelection {}
	$tree delete seleBox
	foreach i $allObjList {
		set oname [file tail $i]
		if {[lsearch $olist $oname]!=-1} {
			Tree:drawselection $i
			lappend TreeSelection $i
		}
	}
	_selectedCount
}

proc _listAllObjsInGhostForFind {x y} {
	global lboxGhost lboxGhostLabel allObjList
	bind $lboxGhost <ButtonRelease-1> {
		set csel [$lboxGhost curselection]
		if {$csel=={}} break
		_highlightTree [$lboxGhost get $csel]
		wm withdraw .lb
	}
	$lboxGhostLabel config -text "Find in tree"
	set allObjListSorted {}
	$lboxGhost delete 0 end
	foreach i $allObjList {
		set n [file tail $i]
		lappend allObjListSorted $n
	}	
	foreach i [lsort $allObjListSorted] {$lboxGhost insert end $i}	
	_showGhostLbox $x $y
}

proc _listAllObjsInGhostForMat {X Y x y} {
	global lboxGhost lboxGhostLabel lbMats tree treeSingleObject
	set name [Tree:labelat $tree $x $y]
	
	bind $lboxGhost <ButtonRelease-1> {
		set csel [$lboxGhost curselection]
		if {$csel=={}} break
		set mat [$lboxGhost get $csel]
		$lbMats selection clear 0 end
		$lbMats selection set [lsearch [$lbMats get 0 end] $mat]
		set who [$lboxGhostLabel cget -text]
		if {$who=="Assign to tree selection"} {
			_setMatToSele add
		} else {
			_setMatToObj add single $treeSingleObject
		}
		wm withdraw .lb
	}

	if {$name!=""} {
		$lboxGhostLabel config -text "[file tail $name]"
		set treeSingleObject $name
	} else {
		$lboxGhostLabel config -text "Assign to tree selection"
	}
	
	$lboxGhost delete 0 end
	set mats [$lbMats get 0 end]
	foreach i $mats {
		$lboxGhost insert end $i
	}
	_showGhostLbox $X $Y
}

