proc _ghostScale {} {
	global currScaleComm
	toplevel .p
	wm overrideredirect .p 1
	wm withdraw .p
	scale .p.s -relief raised -orient horiz -width 10 -length 150 -fg blue
	pack .p.s -padx 0
	bind .p.s <ButtonRelease-1> {
		wm withdraw .p
		if {$currScaleComm!="n"} {eval $currScaleComm}
	}
	bind .p <Leave>             {wm withdraw .p}
	bind .p <Escape>            {wm withdraw .p}
}

proc _ghostLbox {} {
	global gui lboxGhost lboxGhostLabel
	toplevel .lb
	wm overrideredirect .lb 1
	wm withdraw .lb
	frame .lb.f
	set lboxGhostLabel [label .lb.f.lb -relief sunken]
	set lboxGhost [listbox .lb.f.l -height 8 -yscrollcommand {.lb.f.s set} \
		-fg $gui(activeColor) -selectforeground $gui(activeColor)]
	scrollbar .lb.f.s -command {.lb.f.l yview} -orient vert
	pack .lb.f -fill x -expand 1
	pack .lb.f.lb -side top -fill x -expand 1
	pack .lb.f.l -side left -fill x -expand 1
	pack .lb.f.s -side right -fill y
	bind .lb.f <Leave> {wm withdraw .lb}
	bind .lb <Escape>  {wm withdraw .lb}
}

proc _insertSeparator {path} {
	frame $path -relief raised -bd 2 -height 3
	pack $path -fill x -expand 1 -pady 2
}

proc _insertLbEn {path w1 w2 txt var} {
	# 
	# w1 -> larghezza label, w2 -> larghezza entry, txt -> testo label
	# var -> textvariable di entry
	# 
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	entry $path.en -width $w2 -textvar $var
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.en -side right
}

proc _insertLbLbs {path w1 w2 txt var from to res comm} {
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	label $path.lb1 -relief raised -width $w2 -textvar $var
	bind $path.lb1 <1> "_showGhostScale %X %Y $var $from $to $res [list $comm]"
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.lb1 -side right
}

proc _showGhostScale {x y var from to res comm} {
	global currScaleComm
	set currScaleComm $comm
	.p.s config -var $var -from $from -to $to -res $res
	set wx [winfo width .p]
	set wy [winfo height .p]
	wm geometry .p +[expr $x-$wx/2]+[expr $y-$wy/2]
	wm deiconify .p
	focus .p.s
}

proc _showGhostLbox {x y} {
	global lboxGhostLabel
	set wx [winfo width .p]
	set wy [winfo height .p]
	wm geometry .lb +[expr $x-$wx/2]+[expr $y-$wy/2]
	wm deiconify .lb
	focus $lboxGhostLabel
}

proc _insertLbCb {path w1 txt var} {
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	checkbutton $path.cb -var $var
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.cb -side right
}

proc _insertLb3En {path w1 w2 txt var1 var2 var3 mess1 mess2 mess3} {
	# 
	# w1 -> larghezza label, w2 -> larghezza entry, txt -> testo label
	# var -> textvariable di entry
	# 
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	entry $path.en1 -width $w2 -textvar $var1
	entry $path.en2 -width $w2 -textvar $var2
	entry $path.en3 -width $w2 -textvar $var3
	_bindEnterLeave $path.en1 $mess1
	_bindEnterLeave $path.en2 $mess2
	_bindEnterLeave $path.en3 $mess3
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.en3 $path.en2 $path.en1 -side right
}

proc _insertLbMb {path w1 w2 txt entries accel var} {
	global $var
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	label $path.mb -relief raised -width $w2 -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i"
		incr cnt
	}
	pack $path -fill x -expand 1
	pack $path.lb -side left
	pack $path.mb -side right
}

proc _insertLbMb1 {path w1 w2 txt entries accel comm var} {
	global $var
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	label $path.mb -relief raised -width $w2 -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i; $comm"
		incr cnt
	}
	pack $path -fill x -expand 1
	pack $path.lb -side left
	pack $path.mb -side right
}

proc _insertLbMb2 {path w1 w2 txt entries accel comm var} {
	# 
	# Specifica per camera view
	# 
	global $var
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt
	label $path.mb -relief raised -width $w2 -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		set c [lindex $comm $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i; $c"
		incr cnt
	}
	pack $path -fill x -expand 1
	pack $path.lb -side left
	pack $path.mb -side right
}

proc _insertLbBt {path w1 w2 txt1 txt2 comm} {
	# 
	# w1 -> larghezza label, w2 -> larghezza menubt
	# txt1 -> testo label, txt2 -> testo button
	# var -> textvariable di Cb
	# 
	frame $path
	label $path.lb -anchor w -width $w1 -text $txt1
	button $path.b -text $txt2 -width $w2 -comm $comm
	pack $path -fill x -expand 1
	pack $path.lb -side left
	pack $path.b -side right
}

proc _insertLbColor {path w wdt label var} {
	frame $path
	label $path.lb -anchor w -text "$label"
	label $path.cc -width $wdt -relief raised
	bind $path.cc <ButtonRelease-1> "_insertLbColorDialog $path $w $var n"
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.cc -side left
}

proc _insertLbColorDialog {path w var comm} {
	global $var
	set ccol [$path.cc cget -bg]
	set col [tk_chooseColor -parent $w -initialcolor $ccol]
	if {$col==""} return
	$path.cc config -bg $col
	catch {_rgbColor $col} rgb
	set [set var](red) [lindex $rgb 0]
	set [set var](green) [lindex $rgb 1]
	set [set var](blue) [lindex $rgb 2]
	if {$comm!="n"} {eval $comm}
}

proc _insertCbLbEn {path wdt txt var0 var1 comm} {
	# 
	# var0 variabile di checkbutton
	# wdt -> larghezza entry, txt -> testo cb
	# var1 -> textvariable di entry
	# 
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -bd 0 -comm $comm
	entry $path.en1 -width $wdt -textvar $var1
	bind $path.en1 <Key-Return> "eval $comm"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.en1 -side right
}

proc _insertCbLb2En {path wdt txt var0 var1 var2 mess1 mess2} {
	# 
	# var0 variabile di checkbutton
	# w1 -> larghezza label, w2 -> larghezza entry, txt -> testo label
	# var1/2 -> textvariable di entry
	# 
	frame $path
	checkbutton $path.cb -text $txt -var $var0
	entry $path.en1 -width $wdt -textvar $var1
	entry $path.en2 -width $wdt -textvar $var2
	_bindEnterLeave $path.en1 $mess1
	_bindEnterLeave $path.en2 $mess2
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.en2 $path.en1 -side right
}

proc _insertCbLb3En {path wdt txt var0 var1 var2 var3 mess1 mess2 mess3} {
	# 
	# var0 variabile di checkbutton
	# w1 -> larghezza label, w2 -> larghezza entry, txt -> testo label
	# var -> textvariable di entry
	# 
	frame $path
	checkbutton $path.cb -text $txt -var $var0
	entry $path.en1 -width $wdt -textvar $var1
	entry $path.en2 -width $wdt -textvar $var2
	entry $path.en3 -width $wdt -textvar $var3
	_bindEnterLeave $path.en1 $mess1
	_bindEnterLeave $path.en2 $mess2
	_bindEnterLeave $path.en3 $mess3
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.en3 $path.en2 $path.en1 -side right
}

proc _insertCbLbMb {path wdt txt entries accel var0 var comm} {
	global $var
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -comm $comm
	label $path.mb -relief raised -width $wdt -textvar $var
	menu $path.mb.m -tearoff 0
	bind $path.mb <ButtonRelease-1> "tk_popup $path.mb.m %X %Y"
	set cnt 0
	foreach i $entries {
		set a [lindex $accel $cnt]
		$path.mb.m add command -label $i -accel $a -command "set $var $i; eval $comm"
		incr cnt
	}
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.mb -side right
}

proc _insertCbLbLbs {path wdt txt var0 var from to res comm} {
	frame $path
	checkbutton $path.cb -text $txt -var $var0 -comm $comm
	label $path.lb -relief raised -width $wdt -textvar $var
	bind $path.lb <1> "_showGhostScale %X %Y $var $from $to $res [list $comm]"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.lb -side right
}

proc _insertCbLbBt {path wdt txt var comm1 comm2} {
	frame $path
	checkbutton $path.cb -text $txt -var $var -comm $comm1
	label $path.lb -relief raised -width $wdt
	bind $path.lb <1> "[list $comm2]"
	pack $path -fill x -expand 1
	pack $path.cb -side left -anchor w
	pack $path.lb -side right
}

proc _insertCbLbColor {path w wdt label var0 var comm} {
	frame $path
	checkbutton $path.cb -anchor w -text $label -var $var0 -comm $comm
	label $path.cc -width $wdt -relief raised
	bind $path.cc <ButtonRelease-1> "_insertLbColorDialog $path $w $var [list $comm]"
	pack $path -fill x -expand 1
	pack $path.cb -side left
	pack $path.cc -side right
}

proc _insertApplyDismiss {path w g comm} {
	frame $path -relief sunken -bd 2
	button $path.ok -text "Apply" -command $comm
	button $path.cn -text "Dismiss" -command "destroy $w; grab $g"
	# bind $w <Key-Return> "$path.ok invoke"
	pack $path -fill x -expand 1
	pack $path.ok $path.cn -side left -fill x -expand 1 -padx 2 -pady 2
	focus $w
}

proc _insertApplyDismiss2 {path w g comm} {
	# 
	# Fa withdraw invece di destroy $w
	# 
	frame $path -relief sunken -bd 2
	button $path.ok -text "Apply" -command "$comm"
	button $path.cn -text "Dismiss" -command "wm withdraw $w; grab $g"
	# bind $w <Key-Return> "$path.ok invoke"
	pack $path -fill x -expand 1
	pack $path.ok $path.cn -side left -fill x -expand 1 -padx 2 -pady 2
	focus $w
}

proc _insert2Butt {path w1 w2 l1 l2 comm1 comm2} {
	frame $path -relief sunken -bd 2
	button $path.b1 -text "$l1" -command $comm1 -width $w1
	button $path.b2 -text "$l2" -command $comm2 -width $w2
	pack $path -fill x
	pack $path.b1 $path.b2 -side left -fill x -expand 1 -padx 2 -pady 2
}

proc _insertApplyOtherDismiss {path w g lb2 comm1 comm2} {
	frame $path -relief sunken -bd 2
	button $path.ok -text "Apply" -command $comm1
	button $path.ot -text "$lb2" -command $comm2
	button $path.cn -text "Dismiss" -command "destroy $w; grab $g"
	# bind $w <Key-Return> "$path.ok invoke"
	pack $path -fill x -expand 1
	pack $path.ok $path.ot $path.cn -side left -fill x -expand 1 -padx 2 -pady 2
	focus $w
}

proc _insertColorFrame {path w label var} {
	frame $path
	frame $path.f1
	label $path.f1.lb -anchor w -text "$label"
	button $path.f1.cc -width 4 -command "_insertColorFrameDialog $path $w $var"
	_bindEnterLeave $path.f1.cc "Set Intensity color"
	frame $path.f2
	label $path.f2.r -relief ridge -bd 2 -textvar [set var](red)
	label $path.f2.g -relief ridge -bd 2 -textvar [set var](green)
	label $path.f2.b -relief ridge -bd 2 -textvar [set var](blue)
	_bindEnterLeave $path.f2.r "Red"
	_bindEnterLeave $path.f2.g "Green"
	_bindEnterLeave $path.f2.b "Blue"
	pack $path $path.f1 $path.f2 -fill x -expand 1
	pack $path.f1.lb -side left -fill x -expand 1
	pack $path.f1.cc -side left
	pack $path.f2.r $path.f2.g $path.f2.b -side left -fill x -expand 1
}

proc _insertColorFrameDialog {path w var} {
	global $var
	set ccol [$path.f1.cc cget -bg]
	set col [tk_chooseColor -parent $w -initialcolor $ccol]
	if {$col==""} return
	$path.f1.cc config -bg $col
	catch {_rgbColor $col} rgb
	set [set var](red) [lindex $rgb 0]
	set [set var](green) [lindex $rgb 1]
	set [set var](blue) [lindex $rgb 2]
}

proc _insertSetDir {path w1 var bcomm} {
	global opIm $var
	frame $path
	label $path.lb -anchor w -width $w1 -relief ridge -bd 2 -textvariable $var
	button $path.b -image $opIm -comm $bcomm
	pack $path -fill x -expand 1
	pack $path.lb -side left -fill x -expand 1
	pack $path.b -side right -fill y
}

proc _insertText {path w h bg fg font name} {
	global gui $name
	frame $path
	frame $path.t
	set $name [
		text $path.t.txt -xscrollcommand "$path.sx set" -exportselection false \
		-yscrollcommand "$path.t.sy set" -wrap none -width $w -height $h \
		-font $font -bg $bg -fg $fg
	]
	scrollbar $path.t.sy -command "$path.t.txt yview" -orient vert
	scrollbar $path.sx -command "$path.t.txt xview" -orient horiz
	pack $path.t.txt -side left -fill both -expand 1
	pack $path.t.sy -fill y -expand 1
	pack $path.sx -fill x -side bottom
	pack $path.t -fill both -expand 1
	pack $path -fill both -expand 1
}

proc _messageText {f tit btLsb btCms} {
	# 
	# $f prendera' il grab
	# $btLsb e' la lista degli eventuali altri bottoni (label)
	# $btCms e' la lista dei comandi dei rispettivi buttons
	# 
	global commText gui
	toplevel .cmt
	wm title .cmt "$tit"
	wm transient .cmt .
	bind .cmt <Escape> "grab $f; destroy .cmt"
	frame .cmt.t
	set commText [text .cmt.t.txt -xscrollcommand {.cmt.sx set} -exportselect false \
		-yscrollcommand {.cmt.t.sy set} -wrap none -width 80 -font $gui(mtextFont) \
		-height 30 -cursor left_ptr -bg grey45 -fg white]
	scrollbar .cmt.t.sy -command {$commText yview} -orient vert
	scrollbar .cmt.sx -command {$commText xview} -orient horiz
	frame .cmt.b -relief ridge -bd 2
	button .cmt.b.b -text "Dismiss" -command "grab $f; destroy .cmt"
	pack $commText -side left -fill both -expand 1
	pack .cmt.t -fill both -expand 1
	pack .cmt.t.sy -fill y -expand 1
	pack .cmt.sx -fill x
	pack .cmt.b -fill x -padx 2 -pady 2
	pack .cmt.b.b -side right -anchor e
	set cnt 0
	foreach b $btLsb {
		button .cmt.b.b$cnt -text "$b" -command "[lindex $btCms $cnt]"
		pack .cmt.b.b$cnt -side right -anchor e
		incr cnt
	}
	focus $commText
	grab .cmt
	_placeAtCenter .cmt
}

proc _messageTextInsert {txt} {
	global commText
	$commText config -state normal
	$commText insert end "$txt"
	$commText config -state disabled
}

proc _insertOptFrame1 {path lab} {
	frame $path -relief ridge -bd 2
	label $path.lb -text $lab -fg white
	pack $path -padx 2 -pady 2 -fill x -expand 1
	if {$lab!=""} {pack $path.lb -anchor w}
}

proc _insertOptFrame2 {path lab var} {
	frame $path -relief ridge -bd 2
	frame $path.f
	checkbutton $path.f.cb -var $var
	label $path.f.lb -text $lab -fg white
	pack $path -padx 2 -pady 2 -fill x -expand 1
	pack $path.f -fill x -expand 1
	pack $path.f.cb $path.f.lb -side left -anchor w
}

proc _insertCanvas {path name w h side} {
	global $name canvas
	frame $path
	frame $path.y
	set $name [canvas $path.y.c -bg $canvas(bg) -width $w -height $h \
		-yscrollcommand "$path.y.sb set" -xscrollcommand "$path.sb set" \
		-relief sunken -bd 2 -xscrollincrement 1 -yscrollincrement 1
	]
	bind $path.y.c <2> "$path.y.c scan mark %x %y"
	bind $path.y.c <B2-Motion> "$path.y.c scan dragto %x %y"
	scrollbar $path.y.sb -orient vertical -command "$path.y.c yview"
	scrollbar $path.sb -orient horiz -command "$path.y.c xview"
	pack $path -side $side -fill both -expand 1
	pack $path.y -fill both -expand 1
	pack $path.y.c -side left -fill both -expand 1
	pack $path.y.sb -fill y -expand 1
	pack $path.sb -fill x
}

